import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import processing.serial.*; 
import javax.swing.ImageIcon; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class ColorMotionV2 extends PApplet {

/*
This software was created by www.ChromationSystems.com for use with RGB LED Controllers

You should not be reading this. The source is not to be modified or made available. 
This code has been stripped of all comments and println(). 
And some variables have been obfusicated to prevent reverse engineering.

But if you have a project so important that you really need to modify this software, please contact
at Support@www.ChromationSystems.com, I am quite reasonable so we may be able to work something out.

*/




int inByte;
int inByte1;
int inByte2;
int CmdByte=0;
int DataByte1=0;
int DataByte2=0;
int temp=0;
int MiliSec = 0;
int SettingInfoColSelect = 0; 
int ByteCounter =0;
String DevStatus = "Unconnected";
String DeviceName= "Unconnected";
String DeviceFirmware = "Firmware Unknown";
int HardwareID=0;
int FirmwareV=0;
int FirmwareRev=0;
int DeviceMaxPerChan=16;
int DeviceMaxFrames = 64;
int DeviceWORDsize = 32;
int DeviceDemoFrames = 0;
int DeviceArraySize = 48; 
boolean MultiSupportFlag = false;
int LEDTotal = 32; 
int LEDChanTotal = 24;
int LEDsPerChan = 4;
int HoldColorPick=0;
int SelectedLEDico=0;
int DelayCounter=0;  
int ReceptionCounter = 0;
int PacketSize = 0;
int FileBrowserAction =0;
String FWR[] = {
  "a", "b", "c", "d", "e", "f", "g", "h", "i"
};
int[] CopyStorage = new int[300];
int[][][] GreyScaleStorage = new int[8][128][300]; 
int[][][] GreyScaleHold = new int[8][128][300];
int[][] var388sa = new int[8][300];
int LSideButtonsSel=0;
int RSideButtonsSel=0;
int var37ad3=0;
int var3345aj=0;
int SelectedFrame=0;
int SelectedLED=0;
int SliderSet=0;
int ConfigShape=1;
int LastHelpNum=0;
int OffsetSelectedFrame=0;
int OffsetMaxFrames[] = {
  2, 2, 2, 2, 2, 2, 2, 2
};
int[][] var993za = new int[8][16];
int NextFrame=1;
int PrevFrame=0;
int[] SlideBuild = new int[256];
int LinkerMap[] = {
  0, 1, 2, 3, 4, 5, 6, 7
};
int MultiLinkerMap[][] = {
  {
    0, 1, 2, 3, 4, 5, 6, 7, 255, 255, 255, 255
  }
  , {
    7, 1, 2, 3, 4, 5, 6, 0, 255, 255, 255, 255
  }
  , {
    7, 1, 2, 3, 4, 5, 6, 0, 255, 255, 255, 255
  }
  , {
    7, 1, 2, 3, 4, 5, 6, 0, 255, 255, 255, 255
  }
};
int MultiCounter[][]= {
  {
    4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 0
  }
  , 
  {
    4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 1
  }
  , 
  {
    4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 2
  }
  , 
  {
    4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 3
  }
};
int SelectedMulti=0;
int OffsetWork = 0;
int TotalFrames=0;
int ShapeSize = 340; 
int centX=512;
int centY=420;
int LEDSize=20;
float theta = 0.1f;
int coils = 9;
int radius = 340; 
int rotation = 0;
final float thetaMax = coils * 2 * PI;
final float awayStep = radius / thetaMax;
final int chord = 35;
int iterationcounter=0;
int AutoCount=0;
int AutoTry=0;
int CharCounter=0; 
int LoadingBarDiv=19;
int LineDragNum=0;
int UploadCounter=0;
int SelectedSlider=0;
String SelectedLocation="saves/save_1.csmm";
String SaveLocs[] = {
  "saves/save_1.csmm", "saves/save_2.csmm", "saves/save_3.csmm", "saves/save_4.csmm", "saves/save_5.csmm", 
  "saves/save_6.csmm", "/saves/preset1.csmm", "/saves/preset2.csmm", "/saves/preset3.csmm"
};
String[] PrevString = new String[8];
boolean LiveModeSent=false;
boolean RequestSent=false;
boolean ConfirmedFlag=false;
boolean DeviceConnected=false;
boolean ConnectionRequestSent=false; 
boolean UploadingFlag=false;
boolean UploadRequestSent=false;
boolean SettingsRequestSent=false;
boolean DemoRequestSent=false;
boolean LiveMode=false;
boolean LiveModeGradientOpen=false;
boolean LineDraggingLinker=false;
boolean LineDraggingMulti=false;
boolean COMselected=false;
boolean AutoConnect=false;
boolean ColorPickerOpen=false;
boolean RadialOpen=false;
boolean AllTheSameFlag=false;
boolean SaveConfirm=false;
boolean SaveOrLoad=false;
boolean IgnoreRelease=false;
boolean GlobalDragging=false; 
boolean DotCorrectionRequestSent = false;
boolean EditPaintValue = false;
boolean DotCorrectionEnabled= false;
int PaintValue = color(255);
final int SketchBGColor =color(220, 220, 220);
final int SketchGenFontColor =color(0);
final int LinkerLineColor = color(0, 150, 255);
final int SliderBG = color(127);
final int SliderHandCol = color(0);
final int SliderSelCol = color(100);
final int SliderStroke = color(0);
final int ColButtonsHL = color(25, 25, 70);
final int ColButtonsBG = color(45, 45, 145);
String portName;
Serial myPort;  
PFont font;
SliderBar[] ConfigSliders;
SliderBar[] SpeedSliders;
SliderBar[] GreyValueSliders;
SliderBar[] SlideFrameSliders;
SliderBar[] MultiSliders;
SliderBar[] LiveModeSliders;
VertSliderBar[][] VertSliders;
SliderBar[] ColorSlider;
SliderBar[] DotCorrection;
SliderBar[] ControlSlider;
PatternFrames[][] SettingFrames;
UserSettingsObj[] UserSettings;
Button[][] SettInfoButtons;
Button[] Buttons;
Button[] LinkerButtons;
Button[] ConfigButtons;
Button[] COMButtons; 
Button[] OffsetButtons; 
SideBar[] LSideButtons; 
SideBar[] RSideButtons;
Button[] WorkSpaceButtons;
Button[] ConfigFuncButtons;
Button[] ControlButtonsA;
Button[] ControlButtonsB;
SideBar[] SaveLoadButtons;
SideBar[] LiveModeButtons;
GUIMenu[] GUIMenus;
Button[] AddFrameButtons;
LEDgraphic[] LEDIcon;
PImage BackGround, Roverlay, Loverlay, ConfigMenuImg;
PImage RButtons, LButtons;
PImage LiveModeGradient, PointMark;
PImage ColorPicker;
PImage RadialMenu, RadialMenuLrg;
PImage OffsetMenu;
PImage SettingsInfo;
PImage SaveLoadMenu;
PImage SaveLoadOverlay;
PImage PresetOverlay;
PImage LiveModeMenu;
PImage LiveModeOverlay;
PImage LoadingBox;
PImage SendingBox;
PImage LinkerMenu;
PImage ConfirmBox;
PImage MultiMenu, ControlMenu;
PImage MultiPressed, SideGradient;
public void setup()
{
  size(1024, 768);
  background(SketchBGColor);
  frameRate(15); 
  font = createFont("SansSerif", 16);
  textFont(font, 16); 

  ImageIcon titlebaricon = new ImageIcon(loadBytes("favicon.gif"));
  frame.setIconImage(titlebaricon.getImage());
  
  BackGround=loadImage("background.png");
  Roverlay=loadImage("rbuttonover.png");
  Loverlay=loadImage("lbuttonover.png");
  ConfigMenuImg=loadImage("configmenu.png");
  RButtons = loadImage("rbuttons.png");
  LButtons = loadImage("lbuttons.png");
  ColorPicker = loadImage("colorpick.png");
  RadialMenu = loadImage("radialmenu.png");
  OffsetMenu = loadImage("offsetmenu.png");  
  SettingsInfo = loadImage("settingsinfo.png");  
  SaveLoadMenu = loadImage("saveload.png");   
  SaveLoadOverlay = loadImage("slbuttonover.png");  
  PresetOverlay = loadImage("presetbuttonover.png");  
  LiveModeMenu = loadImage("livemodemenu.png");
  LiveModeOverlay = loadImage("livemodebuttonover.png");
  LoadingBox = loadImage("loading.png");
  SendingBox = loadImage("sending.png");
  LinkerMenu = loadImage("linkermenu.png");
  ConfirmBox = loadImage("areyousure.png");
  MultiMenu = loadImage("multimenu.png");
  MultiPressed = loadImage("multisetpressed.png");
  SideGradient = loadImage("sidegradient.png");  
  LiveModeGradient = loadImage("livemodegradient.png");
  PointMark = loadImage("mark.png");
  RadialMenuLrg = loadImage("radialmenu-lrg.png");
  ControlMenu = loadImage("controlmenu.png");
  
  SettingFrames = new PatternFrames[8][255]; 
  UserSettings = new UserSettingsObj[8];
  GUIMenus = new GUIMenu[9];
  GUIMenus[0]= new GUIMenu("NoMenu", 130, 100, 745, 600, 0, false);  
  GUIMenus[1]= new GUIMenu("Config", 260, 115, 500, 620, 1, false);
  GUIMenus[2]= new GUIMenu("SettingsInfo", 875, 525, 200, 240, 2, false);  
  GUIMenus[3]= new GUIMenu("OffsetMenu", 155, 525, 700, 175, 3, false);  
  GUIMenus[4]= new GUIMenu("SaveLoad", 240, 125, 500, 550, 4, false);    
  GUIMenus[5]= new GUIMenu("LiveMode", 180, 160, 650, 550, 5, false);      
  GUIMenus[6]= new GUIMenu("LinkerMenu", 300, 150, 400, 500, 6, false);      
  GUIMenus[7]= new GUIMenu("MultiMenu", 250, 150, 400, 500, 7, false);      
  GUIMenus[8]= new GUIMenu("ControlMenu", 250, 150, 500, 300, 8, false);      
  
  LSideButtons = new SideBar[8];
  RSideButtons = new SideBar[8];
  SaveLoadButtons = new SideBar[14];
  LiveModeButtons = new SideBar[3];
  
  ConfigButtons = new Button[50];  
  Buttons = new Button[2];  
  COMButtons = new Button[Serial.list().length+1];
  AddFrameButtons = new Button[120];
  OffsetButtons = new Button[4];
  SettInfoButtons = new Button[8][6];
  LinkerButtons = new Button[23];
  WorkSpaceButtons = new  Button[10];
  ConfigFuncButtons = new  Button[7]; 
 ControlButtonsA = new Button[7]; 
 ControlButtonsB = new Button[20]; 
 
  
  LEDIcon = new LEDgraphic[192];
  
 
  SpeedSliders = new SliderBar[8]; 
  GreyValueSliders = new SliderBar[8];
  SlideFrameSliders = new SliderBar[8];   
  LiveModeSliders = new SliderBar[48];
  MultiSliders = new SliderBar[8]; 
  ColorSlider = new SliderBar[4];
  DotCorrection = new SliderBar[96];
  ControlSlider = new SliderBar[2];
  COMButtons[0] = new Button("Auto", 15, 70, 40, 20, ColButtonsBG, ColButtonsHL, true, false);
  for (int i=1; i <= Serial.list().length;i++)
  {
    COMButtons[i] = new Button(Serial.list()[i-1], 60+((i-1)*45), 70, 40, 20, ColButtonsBG, ColButtonsHL, true, false);
  }
  Buttons[0] = new Button("Setting Up", 700, 30, 75, 20, ColButtonsBG, ColButtonsHL, false, false); 
  Buttons[1] = new Button(" Setting Down", 700, 60, 75, 20, ColButtonsBG, ColButtonsHL, false, false); 
  for (int i=0; i != SpeedSliders.length;i++) SpeedSliders[i] = new SliderBar(890, 565, 120, 10, 1, 1, 255, color(255), color(0), color(200, 200, 200), color(0), true, false);
  for (int i=0; i != SlideFrameSliders.length;i++) SlideFrameSliders[i] = new SliderBar(955, 660, 60, 10, 1, 1, 127, color(255), color(0), color(200, 200, 200), color(0), true, false);
  for (int i=0; i != GreyValueSliders.length;i++)GreyValueSliders[i] = new SliderBar(890, 740, 120, 10, 255, 0, 255, color(255), color(0), color(200, 200, 200), color(0), true, false);
  for (int i=0; i != SettInfoButtons.length;i++)
  {
    SettInfoButtons[i][0] = new Button("Flash", 885, 585, 40, 20, ColButtonsBG, ColButtonsHL, true, false);
    SettInfoButtons[i][1] = new Button("Cycle", 930, 585, 40, 20, ColButtonsBG, ColButtonsHL, true, true);  
    SettInfoButtons[i][2] = new Button("Slide Down", 885, 630, 60, 20, ColButtonsBG, ColButtonsHL, true, false);
    SettInfoButtons[i][3] = new Button("Slide Up", 955, 630, 60, 20, ColButtonsBG, ColButtonsHL, true, false);
    SettInfoButtons[i][4] = new Button("<", 975, 585, 20, 20, ColButtonsBG, ColButtonsHL, true, false);
    SettInfoButtons[i][5] = new Button(">", 1000, 585, 20, 20, ColButtonsBG, ColButtonsHL, true, true);
  }
  
  for (int i=0;i!=8;i++) ConfigButtons[i] = new Button("Chan "+(i+1), 295+((i)*55), 610, 50, 15, color(255), ColButtonsHL, false, false);
  for (int i=8;i!=16;i++)ConfigButtons[i] = new Button("Chan "+(i+1), 295+(((i)-8)*55), 630, 50, 15, color(255), ColButtonsHL, false, false);   
  for (int i=16;i!=24;i++)ConfigButtons[i] = new Button("Chan "+(i+1), 295+(((i)-16)*55), 650, 50, 15, color(255), ColButtonsHL, false, false);   
  for (int i=24;i!=32;i++)ConfigButtons[i] = new Button("Chan "+(i+1), 295+(((i)-24)*55), 670, 50, 15, color(255), ColButtonsHL, false, false);   
  for (int i=32;i!=40;i++)ConfigButtons[i] = new Button("Chan "+(i+1), 295+(((i)-32)*55), 690, 50, 15, color(255), ColButtonsHL, false, false);   
  for (int i=40;i!=48;i++)ConfigButtons[i] = new Button("Chan "+(i+1), 295+(((i)-40)*55), 710, 50, 15, color(255), ColButtonsHL, false, false);   
  ConfigButtons[49] = new Button(" Same", 390, 590, 70, 15, ColButtonsBG, ColButtonsHL, false, false);
  ConfigFuncButtons[0] = new Button("Round", GUIMenus[1].xpos+15, GUIMenus[1].ypos+75, 100, 30, ColButtonsBG, ColButtonsHL, false, false);
  ConfigFuncButtons[1] = new Button("Square", GUIMenus[1].xpos+125, GUIMenus[1].ypos+75, 100, 30, ColButtonsBG, ColButtonsHL, false, false);
  ConfigFuncButtons[2] = new Button("Spiral", GUIMenus[1].xpos+235, GUIMenus[1].ypos+75, 80, 30, ColButtonsBG, ColButtonsHL, false, false);
  ConfigFuncButtons[3] = new Button("Line", GUIMenus[1].xpos+325, GUIMenus[1].ypos+75, 80, 30, ColButtonsBG, ColButtonsHL, false, false); 
  ConfigFuncButtons[4] = new Button("Custom", GUIMenus[1].xpos+415, GUIMenus[1].ypos+75, 80, 30, ColButtonsBG, ColButtonsHL, false, false);  
  ConfigFuncButtons[5] = new Button("Dot Correction", GUIMenus[1].xpos+370, GUIMenus[1].ypos+40, 125, 30, ColButtonsBG, ColButtonsHL, true, false);
  ConfigFuncButtons[6] = new Button("Send", GUIMenus[1].xpos+370, GUIMenus[1].ypos+115, 125, 25, ColButtonsBG, ColButtonsHL, true, false);
  for (int q=0; q != 96;q++) 
    DotCorrection[q] = new SliderBar(GUIMenus[1].xpos+60+((q/24)*120), GUIMenus[1].ypos+155+((q%24)*18), 60, 12, 63, 0, 63, color(255), color(0), color(200, 200, 200), color(0), true, false);
  for (int i=0;i!=120;i++)
  {
    fill(126, 0, 126);  
    if (i < 24) AddFrameButtons[i] =  new Button(""+(i+1), 140+(i*30), 590, 25, 20, color(45, 45, 85), color(45, 105, 45), true, false);
    else if (i >= 24 && i < 48)AddFrameButtons[i] =  new Button(""+(i+1), 140+((i-24)*30), 615, 25, 20, color(45, 45, 85), color(45, 105, 45), true, false);
    else if (i >= 48 && i < 72) AddFrameButtons[i] = new Button(""+(i+1), 140+((i-48)*30), 640, 25, 20, color(45, 45, 85), color(45, 105, 45), true, false);
    else if (i >= 72 && i < 96) AddFrameButtons[i] = new Button(""+(i+1), 140+((i-72)*30), 665, 25, 20, color(45, 45, 85), color(45, 105, 45), true, false);
    else AddFrameButtons[i] = new Button(""+(i+1), 140+((i-96)*30), 690, 25, 20, color(45, 45, 85), color(45, 105, 45), true, false);
  }
  AddFrameButtons[SelectedFrame].Selected=true;
  WorkSpaceButtons[0] = new Button("Reset Setting", 140, 530, 80, 20, color(100, 40, 40), ColButtonsHL, false, false);
  WorkSpaceButtons[1] = new Button("Add Frame", 140, 560, 80, 20, ColButtonsBG, ColButtonsHL, false, false);  
  WorkSpaceButtons[2] = new Button("Remove Frame", 230, 560, 80, 20, ColButtonsBG, ColButtonsHL, false, false);  
  WorkSpaceButtons[3] = new Button("Enable Offset", 700, 560, 80, 20, ColButtonsBG, ColButtonsHL, true, false);  
  WorkSpaceButtons[4] = new Button("Disable Offset", 785, 560, 80, 20, ColButtonsBG, ColButtonsHL, false, false);  
  WorkSpaceButtons[5] = new Button("", 165, 405, 30, 30, ColButtonsBG, ColButtonsHL, true, false);      
  WorkSpaceButtons[6] = new Button("Enable Paint", 145, 450, 75, 20, ColButtonsBG, ColButtonsHL, true, false);   
  WorkSpaceButtons[7] = new Button("Edit Paint", 145, 475, 75, 20, ColButtonsBG, ColButtonsHL, true, false);     
  WorkSpaceButtons[8] = new Button("Copy Frame", 785, 505, 80, 20, color(100, 40, 40), ColButtonsHL, false, false);   
  WorkSpaceButtons[9] = new Button("Paste Frame", 785, 530, 80, 20, color(100, 40, 40), ColButtonsHL, false, false);       
  for (int i=0; i != UserSettings.length;i++) UserSettings[i] = new UserSettingsObj(1, 1, 0, false, true, 0, 0);
  
  for (int q=0; q != 8;q++)
    for (int i=0; i != 255;i++) SettingFrames[q][i] = new PatternFrames(127, 0);
  
  ConfigSliders = new SliderBar[2];
  
  
  ConfigSliders[0] = new SliderBar(GUIMenus[1].xpos+130, GUIMenus[1].ypos+125, 120, 20, 0, 0, LEDTotal, color(255), color(0), color(200, 200, 200), color(0), true, false);
  ConfigSliders[1] = new SliderBar(600, 200, 120, 20, 0, 0, 48, color(255), color(0), color(200, 200, 200), color(0), true, false);
  for (int i=0;i != LSideButtons.length;i++)LSideButtons[i] = new SideBar(""+i, 0, 130+(i*70), 120, 50, true, false, 0);
  for (int i=0;i != RSideButtons.length;i++)RSideButtons[i] = new SideBar(""+i, 885, 120+(i*50), 160, 40, true, false, 1);
  RSideButtons[var3345aj].Selected=true;
  
  OffsetButtons[0]= new Button("Generate", GUIMenus[3].xpos+325, GUIMenus[3].ypos+10, 70, 25, ColButtonsBG, ColButtonsHL, false, false);
  OffsetButtons[1]= new Button("Remove", GUIMenus[3].xpos+410, GUIMenus[3].ypos+10, 70, 25, ColButtonsBG, ColButtonsHL, false, false);
  OffsetButtons[2]= new Button("Add", GUIMenus[3].xpos+495, GUIMenus[3].ypos+10, 70, 25, ColButtonsBG, ColButtonsHL, false, false);
  OffsetButtons[3]= new Button("Close", GUIMenus[3].xpos+240, GUIMenus[3].ypos+10, 70, 25, ColButtonsBG, ColButtonsHL, false, false);
  
  
  
  
  for (int q=0; q != 8;q++)
  for (int i=0; i != 16;i++) var993za[q][i]=color(0);
  ColorSlider[0] = new SliderBar(GUIMenus[3].xpos+105, GUIMenus[3].ypos+50+(20*0), 100, 12, 0, 0, 255, color(127), color(0), color(255, 0, 0), color(0), true, false);
  ColorSlider[1] = new SliderBar(GUIMenus[3].xpos+105, GUIMenus[3].ypos+50+(20*1), 100, 12, 0, 0, 255, color(127), color(0), color(0, 255, 0), color(0), true, false);
  ColorSlider[2] = new SliderBar(GUIMenus[3].xpos+105, GUIMenus[3].ypos+50+(20*2), 100, 12, 0, 0, 255, color(127), color(0), color(0, 0, 255), color(0), true, false);
  ColorSlider[3] = new SliderBar(GUIMenus[3].xpos+105, GUIMenus[3].ypos+30, 100, 12, (LEDChanTotal/3), (LEDChanTotal/3), 128, color(127), color(0), color(200,200,200), color(0), true, false);
  for (int q=0; q != SaveLoadButtons.length;q++) 
  {
    if (q < 6) SaveLoadButtons[q] = new SideBar(""+q, GUIMenus[4].xpos+50, GUIMenus[4].ypos+60+(q*70), 150, 50, false, false, 2);
    else if (q >= 6 && q < 12) SaveLoadButtons[q] = new SideBar(""+q, GUIMenus[4].xpos+300, GUIMenus[4].ypos+60+((q-6)*70), 150, 50, false, false, 2);
    else SaveLoadButtons[q] = new SideBar(""+q, GUIMenus[4].xpos+75+((q-12)*250), GUIMenus[4].ypos+500, 150, 50, false, false, 3);
  }
  
  for (int i=0;i != LiveModeButtons.length;i++) LiveModeButtons[i] = new SideBar(""+i, GUIMenus[4].xpos+170+(i*135), GUIMenus[4].ypos+50, 125, 25, true, false, 4); 
  LiveModeButtons[2].Toggle=false;
  for (int i=0; i != LiveModeSliders.length;i++)
  { 
    if (i < 16) LiveModeSliders[i] = new SliderBar(GUIMenus[4].xpos+20, GUIMenus[4].ypos+90+(i*28), 100, 10, 0, 0, 255, color(255), color(0), color(200, 200, 200), color(0), true, false);
    else if (i >= 16 && i < 32) LiveModeSliders[i] = new SliderBar(GUIMenus[4].xpos+240, GUIMenus[4].ypos+90+((i-16)*28), 100, 10, 0, 0, 255, color(255), color(0), color(200, 200, 200), color(0), true, false);
    else LiveModeSliders[i] = new SliderBar(GUIMenus[4].xpos+440, GUIMenus[4].ypos+90+((i-32)*28), 100, 10, 0, 0, 255, color(255), color(0), color(200, 200, 200), color(0), true, false);
  }
  for (int i=0;i != (LinkerButtons.length-9);i++) LinkerButtons[i] = new Button(""+i, GUIMenus[6].xpos+40, GUIMenus[6].ypos+100+(i*50), 30, 30, ColButtonsBG, ColButtonsHL, false, false);
  for (int i=8;i != (LinkerButtons.length-1);i++) LinkerButtons[i] = new Button(""+i, GUIMenus[6].xpos+250, GUIMenus[6].ypos+100+((i-8)*50), 125, 30, ColButtonsBG, ColButtonsHL, false, false);
  LinkerButtons[16] = new Button("Multi1", GUIMenus[6].xpos+40, GUIMenus[6].ypos+50, 35, 35, color(190, 30, 45), color(120, 15, 10), true, false);
  LinkerButtons[17] = new Button("Multi2", GUIMenus[6].xpos+85, GUIMenus[6].ypos+50, 35, 35, color(190, 30, 45), color(120, 15, 10), true, false);  
  LinkerButtons[18] = new Button("Multi3", GUIMenus[6].xpos+130, GUIMenus[6].ypos+50, 35, 35, color(190, 30, 45), color(120, 15, 10), true, false);
  LinkerButtons[19] = new Button("Multi4", GUIMenus[6].xpos+175, GUIMenus[6].ypos+50, 35, 35, color(190, 30, 45), color(120, 15, 10), true, false);
  LinkerButtons[20] = new Button("DMX", GUIMenus[6].xpos+130, GUIMenus[6].ypos+445, 80, 35, color(190, 30, 45), color(120, 15, 10), true, false);  
  LinkerButtons[22] = new Button("Send", GUIMenus[6].xpos+150, GUIMenus[6].ypos+45, 100, 30, ColButtonsBG, ColButtonsHL, false, false);
  LinkerButtons[21] = new Button("Clear", GUIMenus[6].xpos+120, GUIMenus[6].ypos+260, 100, 60, color(190, 30, 45), color(120, 15, 10), false, false);
  for (int q=0; q != MultiSliders.length;q++)  
    MultiSliders[q]=new SliderBar(GUIMenus[7].xpos+10, GUIMenus[7].ypos+110+(q*50), 75, 10, 4, 1, 96, color(255), color(0), color(200, 200, 200), color(0), true, false);
ControlButtonsA[0] = new Button("Alter Speed", GUIMenus[8].xpos+20, GUIMenus[8].ypos+60, 100, 25, ColButtonsBG, ColButtonsHL, true, true);
ControlButtonsA[1] = new Button("Flash Stepping", GUIMenus[8].xpos+140, GUIMenus[8].ypos+60, 120, 25, ColButtonsBG, ColButtonsHL, true, false);
ControlButtonsA[2] = new Button("Cycle Control", GUIMenus[8].xpos+270, GUIMenus[8].ypos+60, 100, 25, ColButtonsBG, ColButtonsHL, true, false);
ControlButtonsA[3] = new Button("Color Swap", GUIMenus[8].xpos+20, GUIMenus[8].ypos+100, 120, 25, ColButtonsBG, ColButtonsHL, true, false);
ControlButtonsA[4] = new Button("Select Setting and Stall", GUIMenus[8].xpos+320, GUIMenus[8].ypos+100, 160, 25, ColButtonsBG, ColButtonsHL, true, false);
ControlButtonsA[5] = new Button("Select Setting", GUIMenus[8].xpos+170, GUIMenus[8].ypos+100, 120, 25, ColButtonsBG, ColButtonsHL, true, false);
ControlButtonsA[6] = new Button("Pause", GUIMenus[8].xpos+390, GUIMenus[8].ypos+60, 90, 25, ColButtonsBG, ColButtonsHL, true, false);
  for (int i=0;i != 12;i++) 
  {
  if(i < 8)
  {
  ControlButtonsB[i] = new Button(""+(i+1), GUIMenus[8].xpos+30+(i*40), GUIMenus[8].ypos+240, 35, 35, ColButtonsBG, ColButtonsHL, true, false);
  }
  else
  {
  ControlButtonsB[i] = new Button("Multi "+((i+1)-8), GUIMenus[8].xpos+160+((i-8)*70), GUIMenus[8].ypos+200, 60, 25, ColButtonsBG, ColButtonsHL, true, false);
  }
  
  }
 
  ControlButtonsB[0].Selected=true; 
  ControlButtonsB[12] = new Button("Send Cmd.", GUIMenus[8].xpos+360, GUIMenus[8].ypos+240, 120, 35, color(190, 30, 45), color(120, 15, 10), false, false);
  ControlButtonsB[13] = new Button("Up", GUIMenus[8].xpos+160, GUIMenus[8].ypos+200, 60, 25,color(45, 105, 45), ColButtonsHL, false, false);
  ControlButtonsB[14] = new Button("Down", GUIMenus[8].xpos+240, GUIMenus[8].ypos+200, 60, 25,  color(45, 105, 45), ColButtonsHL, false, false);
  ControlButtonsB[15] = new Button("Ignore Linker", GUIMenus[8].xpos+150, GUIMenus[8].ypos+160, 120, 25, ColButtonsBG, ColButtonsHL, true, false);
  ControlButtonsB[16] = new Button("Increment Color Swap", GUIMenus[8].xpos+20, GUIMenus[8].ypos+200, 160, 25, color(45, 105, 45), ColButtonsHL, false, false);
  ControlButtonsB[17] = new Button("Reset Color Swap", GUIMenus[8].xpos+200, GUIMenus[8].ypos+200, 130, 25, color(45, 105, 45), ColButtonsHL, false, false);
  ControlButtonsB[18] = new Button("Toggle Pause", GUIMenus[8].xpos+180, GUIMenus[8].ypos+200, 100, 25,color(45, 105, 45), ColButtonsHL, false, false);
  ControlButtonsB[19] = new Button("Load Demo", GUIMenus[8].xpos+30, GUIMenus[8].ypos+160, 100, 25,color(45, 105, 45), ColButtonsHL, false, false);
 ControlSlider[0] = new SliderBar(GUIMenus[8].xpos+120, GUIMenus[8].ypos+140, 340, 24, 0, 0, 65535, color(255), color(0), color(200, 200, 200), color(0), true, false);
 ControlSlider[1] = new SliderBar(GUIMenus[8].xpos+120, GUIMenus[8].ypos+170, 200, 16, 1, 1, 255, color(255), color(0), color(200, 200, 200), color(0), true, false);
  
  for (int i=0;i != LSideButtons.length;i++)LSideButtons[i].display(); 
  for (int i=0;i != RSideButtons.length;i++)RSideButtons[i].display(); 
  for (int i=0;i != 8;i++) 
    for (int q=0;q != 64;q++)
      for (int c=0;c != 300;c++)
        GreyScaleStorage[i][q][c]=0;
  for (int i=0;i != 8;i++) 
    for (int c=0;c != 300;c++)
      var388sa[i][c]=0;
  for (int i=0; i != UserSettings.length;i++) TotalFrames = TotalFrames + UserSettings[i].FrameLength;
  ShapeSize = 200; 
  centX = 512;
  centY = 340;
  LEDShapeBuild();  
  Refresh();
  delay(20);
  DisplayHelp(5);
}
public void SendDotCorrection()
{
  for(int i=0; i != 96;i++)
  {  
  if(i < 16)  SlideBuild[i] = DotCorrection[15-i].Value;
  else if(i > 15 && i < 32)  SlideBuild[i] = DotCorrection[31-(i-16)].Value;
  else if(i > 31 && i < 48)  SlideBuild[i] = DotCorrection[47-(i-32)].Value;  
  }
  
  for(int i=0; i != LEDChanTotal;i++) 
 { 
  myPort.write(SlideBuild[i]);
 }
UploadingFlag=false;
Refresh();
}
public void SendDemo()
{
 
  LoadingBarDiv=23; 
  myPort.write(SpeedSliders[var3345aj].Value);
  SendDelay();  
  
  myPort.write((UserSettings[var3345aj].FrameLength-1));
  SendDelay(); 
  
  if(UserSettings[var3345aj].FadeFlash==true) myPort.write(1);
  else myPort.write(2);
  SendDelay();
  myPort.write(UserSettings[var3345aj].ForwardReverse);
  SendDelay();  
  
 for(int i=0; i != DeviceArraySize;i++) 
 {
   SendDelay();
   if(UserSettings[var3345aj].FadeFlash==false) myPort.write(0);    
   else  myPort.write(GreyScaleStorage[var3345aj][0][i]); 
  }
 
   for(int i=0; i != DeviceArraySize;i++) 
   {
   SendDelay();
   myPort.write(var388sa[var3345aj][i]);
   }
    int g=0;
    
    for(int q=0; q != 256;q++) SlideBuild[q] = 127; 
    
    for(int i=0; i != UserSettings[var3345aj].FrameLength;i++)
    {
    
    
      if(SettingFrames[var3345aj][i].SlideUpDown == 1)
      {
       SlideBuild[g] = 127 - SettingFrames[var3345aj][i].SlideValue;  
      }
      else if( SettingFrames[var3345aj][i].SlideUpDown == 2) 
      {
       SlideBuild[g] = 127 + SettingFrames[var3345aj][i].SlideValue;   
      }
      else
      SlideBuild[g] = 127;
     g++; 
    }
        
       if(DeviceDemoFrames < 64)
       {
         temp = 64;
       }
       else temp = DeviceDemoFrames;
        
      for(int q=0; q != temp;q++) 
     {
      SendDelay();      
      myPort.write(SlideBuild[q]);
     } 
 
     for(int q=0; q != 28;q++) 
     {
      SendDelay();      
      myPort.write(0);
     } 
 for(int z=0; z != UserSettings[var3345aj].FrameLength;z++)
 for(int i=0; i != LEDChanTotal;i++) 
{
GreyScaleHold[var3345aj][z][i] = GreyScaleStorage[var3345aj][z][i];
}
  
   if(UserSettings[var3345aj].OffsetEnable==true)
   {
    for(int z=0; z != UserSettings[var3345aj].FrameLength;z++)  
    for(int i=0; i != LEDChanTotal;i++)
    {     
     switch(i%3)
    {
     case 0: 
    GreyScaleHold[var3345aj][z][i] = (int)red(var993za[var3345aj][z]); 
    break;
    case 1:
     GreyScaleHold[var3345aj][z][i] = (int)green(var993za[var3345aj][z]);    
    break;
    case 2:
     GreyScaleHold[var3345aj][z][i] = (int)blue(var993za[var3345aj][z]);    
    break;
    }
    }
   }
int CalcMapStart=0;
 for(int z=0; z != UserSettings[var3345aj].FrameLength;z++)
 for(int i=0; i != LEDChanTotal;i++) 
{
CalcMapStart++; 
myPort.write(GreyScaleHold[var3345aj][z][i]);  
SendDelay();
}  

for(int i=0; i != ((DeviceDemoFrames * LEDChanTotal) - CalcMapStart)+200;i++) 
{
 myPort.write(0); 
 SendDelay(); 
}
UploadingFlag=false;
Refresh();
}
public void SendFrameData()
{
   DelayCounter=0;
    
  
   for(int q=0; q != 8;q++)
   for(int z=0; z != UserSettings[q].FrameLength;z++)
   for(int i=0; i != LEDChanTotal;i++) 
  {
  GreyScaleHold[q][z][i] = GreyScaleStorage[q][z][i];
  }
  
 for(int q=0; q != 8;q++)
 {     
   if(UserSettings[q].OffsetEnable==true)
   {
    for(int z=0; z != UserSettings[q].FrameLength;z++)  
    for(int i=0; i != LEDChanTotal;i++)
    {
     switch(i%3)
    {
     case 0: 
    GreyScaleHold[q][z][i] = (int)red(var993za[q][z]); 
    break;
    case 1:
     GreyScaleHold[q][z][i] = (int)green(var993za[q][z]);    
    break;
    case 2:
     GreyScaleHold[q][z][i] = (int)blue(var993za[q][z]);    
    break;
    }    
    SendDelay();
    }
   }
 }
 for(int q=0; q != 8;q++)
 for(int z=0; z != UserSettings[q].FrameLength;z++)
 for(int i=0; i != LEDChanTotal;i++) 
{
myPort.write(GreyScaleHold[q][z][i]);  
SendDelay();
}  
DataByte2 = 64 - DataByte2;

for(int i=0; i != DataByte2;i++) 
{
myPort.write(i); 
SendDelay();
}
UploadingFlag=false;
Refresh();
}
public void SendSettings()
{
  DelayCounter=0;
  LoadingBarDiv=24; 
 ByteCounter = 0;
 
  
  for(int q=0; q != 4;q++)  
  for(int i=0; i != 12;i++)
  {
  SendDelay();   
  myPort.write(MultiLinkerMap[q][i]);
  }
  
  for(int q=0; q != 4;q++)  
  for(int i=0; i != 12;i++)
  {
  SendDelay();    
  myPort.write(MultiCounter[q][i]);
  }
  
  for(int i=0; i != 32;i++) 
  {
   SendDelay();   
  myPort.write(0); 
  }
 int CalcMapStart=0; 
  for(int q=0; q != 8;q++)  
  {
  SendDelay();   
  myPort.write(LinkerMap[q]);
  }    
  
  for(int i=0; i != 8;i++) 
  {
  SendDelay();    
  myPort.write(SpeedSliders[i].Value);
  }
  for(int i=0; i != 8;i++) 
  {
  SendDelay();    
  myPort.write((UserSettings[i].FrameLength-1));
  }
  for(int i=0; i != 8;i++) 
  {
  SendDelay(); 
  
  if(UserSettings[i].FadeFlash==true) myPort.write(1);
  else myPort.write(2);
  }
  for(int i=0; i != 8;i++) 
  {
   SendDelay();
   
   if(i==0)myPort.write(0);
   else
  {
   CalcMapStart = CalcMapStart + UserSettings[i-1].FrameLength;
   UserSettings[i].MapStart=CalcMapStart;
   myPort.write(CalcMapStart);
  }  
  }
  
  for(int i=0; i != 8;i++) 
  {
  SendDelay();   
  myPort.write(UserSettings[i].ForwardReverse); 
  }
  
 for(int q=0; q != 8;q++) 
 for(int i=0; i != DeviceArraySize;i++) 
 {
   SendDelay();
    
   if(UserSettings[q].FadeFlash==false) myPort.write(0);
  
   else myPort.write(GreyScaleStorage[q][0][i]); 
  }
  
   for(int q=0; q != 8;q++) 
   for(int i=0; i != DeviceArraySize;i++) 
   {
   SendDelay();
   myPort.write(var388sa[q][i]);
   }
    int g=0;
   
    for(int q=0; q != 8;q++)     
    for(int i=0; i != UserSettings[q].FrameLength;i++)
    {
    
    
      if(SettingFrames[q][i].SlideUpDown == 1)
      {
       SlideBuild[g] = 127 - SettingFrames[q][i].SlideValue;  
      }
      else if( SettingFrames[q][i].SlideUpDown == 2) 
      {
       SlideBuild[g] = 127 + SettingFrames[q][i].SlideValue;   
      }
      else
      SlideBuild[g] = 127;
     g++; 
    }  
    
 
     for(int q=0; q != 256;q++)
     {
      SendDelay();      
      myPort.write(SlideBuild[q]);
     }
 
   int MaxSettings=0;
   SendDelay(); 
  
   for(int q=0; q != 8;q++) if(LinkerMap[q] != 255) MaxSettings++;
   
   myPort.write(MaxSettings-1);  
   for(int i=0; i != 15;i++) 
   {
     SendDelay(); 
     myPort.write(i); 
   }
 delay(10);
 StartDataUpload();
}
public void SendDelay()
{
  DelayCounter++;
  
  if(DelayCounter >= DeviceWORDsize)
  {
  DelayCounter=0;
  delay(20); 
  image(LoadingBox, 350,300);
  UploadCounter++;
  Float Var = 280 / (float)(floor((PacketSize * LEDChanTotal) / DeviceWORDsize) + LoadingBarDiv);
  noStroke();
  fill(0);
  rect(370, 340, Var*UploadCounter, 19); 
  } 
} 
public void Send8Chan() 
{
 
 
 
  
 
 
 
 DelayCounter=0;
 LoadingBarDiv=35; 
 UploadingFlag=true; 
 int CalcMapStart=0; 
 int MaxSettings=0;
 for(int q=0; q != 8;q++) if(LinkerMap[q] != 255) MaxSettings++;
 
 
 for(int q=0; q != 8;q++) myPort.write(LinkerMap[q]);
 myPort.write(MaxSettings);
 for(int q=0; q != 7;q++) myPort.write(0);  
 for(int q=0; q != 8;q++) myPort.write(0);  
 for(int q=0; q != 8;q++) myPort.write(0);  
  
 delay(10); 
    int g=0;
    for(int q=0; q != 8;q++)
    for(int i=0; i != UserSettings[q].FrameLength;i++)
    {
    
    
      
    
      if(SettingFrames[q][i].SlideUpDown == 1)
      {
       SlideBuild[g] = 127 - SettingFrames[q][i].SlideValue;  
      }
      else if( SettingFrames[q][i].SlideUpDown == 2) 
      {
       SlideBuild[g] = 127 + SettingFrames[q][i].SlideValue;   
      }
      else
      SlideBuild[g] = 127;
     g++; 
    }  
 for(int i=0; i != DeviceMaxFrames;i++)  
 {
 myPort.write(SlideBuild[i]);
 SendDelay();
 }
 
for(int i=0; i != 8;i++) 
{
myPort.write(SpeedSliders[i].Value);
SendDelay();
}
for(int i=0; i != 8;i++) 
{
myPort.write((UserSettings[i].FrameLength-1));
SendDelay();
}
for(int i=0; i != 8;i++) 
{
if(UserSettings[i].FadeFlash==true) myPort.write(2);
else myPort.write(1);
SendDelay();
}
for(int i=0; i != 8;i++) 
{
 if(i==0)myPort.write(0);
 else
{
 CalcMapStart = CalcMapStart + UserSettings[i-1].FrameLength;
 UserSettings[i].MapStart=CalcMapStart;
 myPort.write(CalcMapStart);
}
SendDelay();
}
  
 for(int q=0; q != 8;q++) 
 for(int i=0; i != LEDChanTotal;i++)  
 {
  

  
  if(UserSettings[q].FadeFlash==false) myPort.write(0);
  else  myPort.write(GreyScaleStorage[q][0][i]); 
  SendDelay();
 }
 
 for(int q=0; q != 8;q++) 
 for(int i=0; i != LEDChanTotal;i++)  
 {
 myPort.write(var388sa[q][i]);
 SendDelay();
 }
 
 
 for(int q=0; q != 8;q++)
 for(int z=0; z != UserSettings[q].FrameLength;z++)
 for(int i=0; i != LEDChanTotal;i++) 
{
GreyScaleHold[q][z][i] = GreyScaleStorage[q][z][i];
SendDelay();
}
 for(int q=0; q != 8;q++) 
 {     
   if(UserSettings[q].OffsetEnable==true)
   {
    for(int z=0; z != UserSettings[q].FrameLength;z++)  
    for(int i=0; i != LEDChanTotal;i++) 
    {
     switch(i%3)
    {
     case 0: 
    GreyScaleHold[q][z][i] = (int)red(var993za[q][z]); 
    break;
    case 1:
     GreyScaleHold[q][z][i] = (int)green(var993za[q][z]);    
    break;
    case 2:
     GreyScaleHold[q][z][i] = (int)blue(var993za[q][z]);    
    break;
    }  
    
    }
   }
 }
CalcMapStart=0;
 for(int q=0; q != 8;q++)
 for(int z=0; z != UserSettings[q].FrameLength;z++)
 for(int i=0; i != LEDChanTotal;i++) 
{
CalcMapStart++; 
myPort.write(GreyScaleHold[q][z][i]); 
SendDelay(); 
}
 
 CalcMapStart = 512 - CalcMapStart;
 
 for(int i=0; i != CalcMapStart;i++) 
 {
 myPort.write(0);
 SendDelay();
 }
 
 UploadingFlag=false;
 GUIMenus[var37ad3].display();
}
public void StartDataUpload()
{
  
   PacketSize=0;
   for(int q=0; q != 8;q++)  
   for(int i=0; i != UserSettings[q].FrameLength;i++)
   {
   PacketSize++;
   }
   
   
   
   
   
         UploadRequestSent=true;
          
          SendRequest(); 
          CmdByte=1; 
          DataByte1=floor((PacketSize * LEDChanTotal) / DeviceWORDsize)+1; 
          
          DataByte2=(PacketSize* LEDChanTotal) % DeviceWORDsize; 
}
public void StartSettingsUpload()
{
          UploadCounter=0;       
          SettingsRequestSent=true;
          
          SendRequest(); 
          CmdByte=100; 
          DataByte1=0;
          DataByte2=0;
}
public void StartDotCorrectionUpload()
{
  if(HardwareID != 208 || HardwareID == 160 && FirmwareV == 2)
  {
  
          UploadCounter=0;       
          DotCorrectionRequestSent=true;
          
          SendRequest(); 
          CmdByte=56; 
          DataByte1=0;
          DataByte2=0;  
  }
}
public void StartDemoUpload()
{
  if(DeviceDemoFrames == 0)
  {
   DisplayHelp(32);   
   return; 
  }
  
  if(UserSettings[var3345aj].FrameLength > DeviceDemoFrames)
  {
   DisplayHelp(29);
   return; 
  }
   
  UploadCounter=0;       
  DemoRequestSent=true;
  
  SendRequest(); 
  CmdByte=75; 
  DataByte1=0; 
  DataByte2=0;
}
public void ToggleLiveMode(int toggle)
{
  
  LiveModeSent=true;
  
  SendRequest(); 
  CmdByte=60;
  DataByte1=toggle;
  DataByte2=0;
}
public void SettingsUp()
{
  
  
  SendRequest(); 
  CmdByte=90; 
  DataByte1=0;
  DataByte2=0;
}
public void SettingsDown()
{
  
  
  SendRequest(); 
  CmdByte=91; 
  DataByte1=0;
  DataByte2=0;
}
public void SendRequest()
{ 
 
 if(HardwareID == 208 && FirmwareV == 1)  
  {
  DisplayHelp(31);
  UploadingFlag=false;
  return;
  }
  
  
  if (COMselected==false) 
  {
    
    return;
  }
  else {
    
    try {
    myPort.write('q');
    myPort.write('Q');
    myPort.write('z');
     RequestSent=true; 
    }
    catch(Exception e)
    {
     
    }
  }
}
  public void fileSelected(File selection) 
  {
    if (selection == null) {
      
    } 
    else {
      
      SelectedLocation = selection.getAbsolutePath();
      switch(FileBrowserAction)  
      {
      case 0: 
        break;
      case 1: 
        ConfigShape=6;
        LEDShapeBuild();  
     
        GUIMenus[var37ad3].display();
        break;
      case 2: 
        SaveUserConfigs(SelectedLocation+".csmm");       
        GUIMenus[var37ad3].display();
        DisplayHelp(41);
        break;
      case 3: 
        LoadUserConfigs(SelectedLocation);
         GUIMenus[var37ad3].display();
         DisplayHelp(42);         
        break;    
      }
    }
  }
  
public void LoadHardwareConfig()
{
  
  DevStatus="Connected";
  AutoConnect=false;
  String[] lines = loadStrings("/saves/hardwareconfig.txt"); 
  int sLines=0;  
  
  String[] WorkString = new String[24]; 
  
if(HardwareID==0)
{
  
  
   DeviceName="None";
   LEDChanTotal=0;
  DeviceMaxPerChan=0; 
  DeviceMaxFrames=0; 
  DeviceArraySize = 8;
  
  DeviceFirmware="Firmware Unknown";;
  LEDTotal=0;
  ConfigSliders[0].Maximum=LEDTotal;  
  return;
}
for(int i=1;i != lines.length;i++)
{
  WorkString = split(lines[i], '\t');
  
  if(PApplet.parseInt(WorkString[0]) == HardwareID)
  {
 
   DeviceName=WorkString[1];
   LEDChanTotal=PApplet.parseInt(WorkString[3]);
   
   
  DeviceMaxPerChan = PApplet.parseInt(WorkString[4]); 
  DeviceMaxFrames = PApplet.parseInt(WorkString[6]); 
  DeviceWORDsize = PApplet.parseInt(WorkString[7]); 
  DeviceDemoFrames = PApplet.parseInt(WorkString[8]);
  DeviceArraySize = PApplet.parseInt(WorkString[10]); 
  
  if(PApplet.parseInt(WorkString[9]) == 1) DotCorrectionEnabled = true;
  if(PApplet.parseInt(WorkString[5]) == 0) MultiSupportFlag = false;
  else MultiSupportFlag = true;
  
  if(FirmwareV < 100)
  DeviceFirmware = "Firmware v."+FirmwareV + FWR[FirmwareRev];
  else
  DeviceFirmware = "Demo v."+(FirmwareV-100)+FWR[FirmwareRev];
  
  LEDTotal=LEDChanTotal*DeviceMaxPerChan;
  ConfigSliders[0].Maximum=LEDTotal;
  
  ConfigSliders[0].Value=LEDChanTotal/3;     
  BuildRound();
  ConfigSliders[0].Value=LEDChanTotal/3;  
 
  ColorSlider[3].Minimum = (LEDChanTotal/3);
  ColorSlider[3].Value = (LEDChanTotal/3);    
  }
} 
delay(100);
Refresh();
}
public void FigureSettingsButtons()
{
 
  
  SettInfoButtons[var3345aj][0].Selected=false;
  SettInfoButtons[var3345aj][1].Selected=false;
  SettInfoButtons[var3345aj][2].Selected=false;
  SettInfoButtons[var3345aj][3].Selected=false;
  SettInfoButtons[var3345aj][4].Selected=false; 
  SettInfoButtons[var3345aj][5].Selected=false;  
  
  
  if(UserSettings[var3345aj].FadeFlash==true) 
  {
     SettInfoButtons[var3345aj][1].Selected=true;
     
     if(UserSettings[var3345aj].ForwardReverse==0)
     SettInfoButtons[var3345aj][5].Selected=true;    
     else 
     SettInfoButtons[var3345aj][4].Selected=true; 
     
     SettingFrames[var3345aj][SelectedFrame].SlideValue=127;
     SettingFrames[var3345aj][SelectedFrame].SlideUpDown=0;    
  }
  else 
  {   
     SettInfoButtons[var3345aj][0].Selected=true;
  }
  if(SettingFrames[var3345aj][SelectedFrame].SlideUpDown == 1) 
  {
   SettInfoButtons[var3345aj][2].Selected=true;
  }
  else if(SettingFrames[var3345aj][SelectedFrame].SlideUpDown == 2) 
  {   
   SettInfoButtons[var3345aj][3].Selected=true;    
  }
  else if(SettingFrames[var3345aj][SelectedFrame].SlideUpDown == 0) 
  {
    SlideFrameSliders[var3345aj].Value=1;  
  }
 
  for(int i=0;i != 4; i++) SettInfoButtons[var3345aj][i].display();
  SlideFrameSliders[var3345aj].display();     
}
public void Func01()
{
  
  for (int q=0;q != 64;q++)
  {
    SettingFrames[var3345aj][q].SlideValue=127;
  }
    
  UserSettings[var3345aj].FadeFlash=true; 
  WorkSpaceButtons[3].Selected=true;  
  UserSettings[var3345aj].FrameLength = OffsetMaxFrames[var3345aj];
  UserSettings[var3345aj].OffsetEnable=true;
  SettInfoButtons[var3345aj][0].Selected=false; 
  SettInfoButtons[var3345aj][1].Selected=true;  
  SettInfoButtons[var3345aj][2].Selected=false; 
  SettInfoButtons[var3345aj][3].Selected=false;  
 
  SelectedFrame=0;  
  
  for (int i=0; i != 16;i++)
  {
    var388sa[var3345aj][i] = 0;
  }
  
  int a48dan3 = (256 * OffsetMaxFrames[var3345aj]);
  
  
  float bkj23a = a48dan3  / ColorSlider[3].Value;
  
  
 int var388saCurrent=0; 
 int var388saNext=1; 
 float aab327 = 0; 
  
  a48dan3 = 0;
  GreyScaleStorage[var3345aj][0][0] = (int)red(var993za[var3345aj][0]);
  GreyScaleStorage[var3345aj][0][1] = (int)green(var993za[var3345aj][0]);
  GreyScaleStorage[var3345aj][0][2] = (int)blue(var993za[var3345aj][0]);
  var388sa[var3345aj][0]=0;
  var388sa[var3345aj][1]=0;
  var388sa[var3345aj][2]=0;  

int a58dlw=0;
int a563sh=0;
for (int i=3; i != LEDChanTotal; i++)
{
switch( i%3)
{
  case 0:
    
  a48dan3+= bkj23a; 
  
  if(a48dan3 > 255)
  {
   a48dan3 -= 256;    
   if(var388saNext == (OffsetMaxFrames[var3345aj]-1))
   {
   var388saNext=0; 
   var388saCurrent=(OffsetMaxFrames[var3345aj]-1);
   }
   else
   {
     var388saNext++;
     var388saCurrent++;     
   } 
  } 
  
  aab327 = (float)a48dan3 / 256; 
  
   a58dlw =(int)red(var993za[var3345aj][var388saCurrent]);
   a563sh =   (int)red(var993za[var3345aj][var388saNext]);
   
     
   if(a58dlw == a563sh) 
  { 
   GreyScaleStorage[var3345aj][0][i] =  a58dlw;
  }  
  else if(a58dlw < a563sh)  
  {
   
  GreyScaleStorage[var3345aj][0][i] = (round((a563sh - a58dlw) * aab327)) + a58dlw;  
  }
  else
  {
   
      GreyScaleStorage[var3345aj][0][i] = a58dlw - (round((a58dlw - a563sh) * aab327));  
  }
  var388sa[var3345aj][i]=var388saCurrent;
  
  
  break;
  case 1:
    
   aab327 = (float)a48dan3 / 256; 
   
   a58dlw = (int)green(var993za[var3345aj][var388saCurrent]);
   a563sh =  (int)green(var993za[var3345aj][var388saNext]);
   
    
   if(a58dlw == a563sh) 
  { 
   GreyScaleStorage[var3345aj][0][i] =  a58dlw;
  }  
  else if(a58dlw < a563sh)  
  {
   
  GreyScaleStorage[var3345aj][0][i] = (round((a563sh - a58dlw) * aab327)) + a58dlw;  
  }
  else
  {
   
      GreyScaleStorage[var3345aj][0][i] = a58dlw - (round((a58dlw - a563sh) * aab327));  
  }
  var388sa[var3345aj][i]=var388saCurrent;
  
  
  break;  
  case 2: 
    
    aab327 = (float)a48dan3 / 256; 
  
   a58dlw = (int)blue(var993za[var3345aj][var388saCurrent]);
   a563sh =  (int)blue(var993za[var3345aj][var388saNext]); 
  
    
   if(a58dlw == a563sh) 
  { 
   GreyScaleStorage[var3345aj][0][i] =  a58dlw;
  }  
  else if(a58dlw < a563sh)  
  {
   
  GreyScaleStorage[var3345aj][0][i] = (round((a563sh - a58dlw) * aab327)) + a58dlw;  
  }
  else
  {
   
      GreyScaleStorage[var3345aj][0][i] = a58dlw - (round((a58dlw - a563sh) * aab327));  
  }
  var388sa[var3345aj][i]=var388saCurrent;
  
  
  break;   
}
}

  var37ad3=0; 
  TotalFrames = 0; 
  for (int i=0; i != UserSettings.length;i++) TotalFrames = TotalFrames + UserSettings[i].FrameLength;
  Refresh();
}
public void COMConnect(int COMnum)
{
  
  if (COMselected == true)
  {  
    myPort.stop();
    
    for (int i=1; i <= Serial.list().length;i++)
    {
      COMButtons[i].Selected = false;
      COMButtons[i].display();
    }  
    COMselected=false;
    DeviceConnected=false;
    AutoConnect=false;
    DevStatus="Unconnected";
    ConnectionRequestSent=false;
    HardwareID=0;
    FirmwareV=0;
    portName = "";
    
    LoadHardwareConfig(); 
    DisplayHelp(3);
    return;
  }
  else { 
    try
    {
      portName = Serial.list()[COMnum];
      myPort = new Serial(this, portName, 19200);
      COMselected=true;
      
      CmdByte=4; 
      DataByte1=0; 
      DataByte2=0;      
      SendRequest();        
      ConnectionRequestSent=true;
      ReceptionCounter =0;    
    }
    catch(Exception e)
    {
      
      COMButtons[COMnum+1].Selected = false;
      COMButtons[COMnum+1].display();
    }      
    DisplayHelp(3);
  }
  
  UploadRequestSent=false;
}
public void DisplayHelp(int type)
{
  noStroke();
  fill(SketchBGColor);
  rect(280, 40, 390, 55); 
  textSize(12);
  fill(SketchGenFontColor);
  if (type==1) text("Multi Linker Not Yet Added. Please Check for Updates", 280, 40, 390, 45);
  else if (type==2) text("Sound Reactivity Not Yet Added. Please Check for Updates", 280, 40, 390, 45);    
  else if (type==3) text("No Compatible Devices Found, Check USB Connections and Ensure the Device is powered up. Then Restart the software.", 280, 40, 390, 75);                  
  else if (type==4) text("Multi Settings not implemented on connected device.", 280, 40, 390, 45);  
  else if (type==5)text("Please Select a COM port to connect to. Or use the Auto Button. If no device is found, but is plugged in, restart the software.", 280, 40, 390, 75);  
  else if (type==6) text("Save/Load Successful", 280, 40, 390, 45);  
  else if (type==7) text("Save/Load Canceled", 280, 40, 390, 45);   
  else if (type==8) text("Command Failed, Check The Connection And try command again. If it fails restart the Device and Software", 280, 40, 390, 75);    
  else if (type==9) text("After a slider has been selected their values can be changed by using the Up/Down/Left/Right Arrow Keys on your keyboard", 280, 40, 390, 75);      
  else if (type==10) text("Please Visit www.ChromationSystems.com/colormotion for instructions, info and updates.", 280, 40, 390, 75);       
  else if (type==11) text("This function is not avaiable when using the Demonstration Firmware. Please visit the website to purchase a microcontroller with compatible firmware. Or use the Demo button to view a pattern.", 280, 40, 390, 75);       
  else if (type==12) text("Selected COM Port is in use or unreachable", 280, 40, 390, 75);       
  else if (type==13) text("Frame Select Not an Option in Offset Mode. Everything is generated, either Upload or click the Disable Offset button to cancel the offset and return to normal usage.", 280, 40, 390, 75);      
  else if (type==14) text("Maximum Frames Reached, Either maximum for the device or Maximum that the software supports. Try removing some from other settings.", 280, 40, 390, 75);      
  else if (type==15) text("Offset Frame is not enabled for this Setting.", 280, 40, 390, 75);      
  else if (type==16) text("Use the Add/Remove Buttons to select the amount of frames needed. Then Click a Frame square to select, it will highlight, then adjust the sliders to the desired color. Repeat with more frames, when finished press Generate", 280, 40, 390, 75);   
  else if (type==17) text("This Frame is set to Slide. Please use the lower left panel to alter this setting. ", 280, 40, 390, 75);   
  else if (type==18) text("Offset Settings can only be Cycles. Please click the Disable Offset button to switch to a different mode. The values can not be altered.", 280, 40, 390, 75);   
  else if (type==19) text("Click on the circles to open the greyscale gradient menu, click the Frame buttons or use the Offset Setting Button to create a pattern.", 280, 40, 390, 75);   
  else if (type==20) text("Select the shape and LED amount, then optionally, use the Channel Color Buttons to select a display color. Color does not affect the pattern or effects and is just for display.", 280, 40, 390, 75);   
  else if (type==21) text("Please close the current menu first.", 280, 40, 390, 75);   
  else if (type==22) text("Click a Save button to save the current settings, or a Load button to load settings. Or load the preset, choose the correct one for your controller.", 280, 40, 390, 75);   
  else if (type==23) text("Click the Enter Live Mode Button, then adjust the sliders to change the channel values. Press Leave Live Mode before exiting the menu.", 280, 40, 390, 75);   
  else if (type==24) text("Not yet Implemented, check for new version.", 280, 40, 390, 75);   
  else if (type==25) text("Use the Sliders to adjust the amount of LEDs, then use the Color Channnel buttons to pick a display color.", 280, 40, 390, 75);   
  else if (type==26) text("A web browser should have opened to www.chromationsystems.com/monomotion.html Updates, Instructions and Download can be found there.", 280, 40, 390, 75);   
  else if (type==27) text("Connect the lines from the white circles to the Settings, this is the order they can be switched through when pressing the button(s).", 280, 40, 390, 75); 
  else if (type==28) text("Connect the lines from the white circles to the Settings, This will be the order the multi pattern cycles through.", 280, 40, 390, 75); 
  else if (type==29) text("Setting has too many frames to Demonstarte. Pleaes remove some. Current Device has a maximum of "+DeviceDemoFrames+".", 280, 40, 390, 75); 
  else if (type==30) text("Forward and Reverse can only be utilized in a Cycle Setting.", 280, 40, 390, 75); 
  else if (type==31) text("Firmware Version Not Supported, Please use older version, or contact for help.", 280, 40, 390, 75); 
  else if (type==32) text("Current Device does not support Demonstration", 280, 40, 390, 75); 
  else if (type==33) text("Incompatible Save File, Please try a different or make a new one.", 280, 40, 390, 75);   
  else if (type==34) text("Precisely edit the Paint Value using the Slider Bar in the bottom left corner.(Indicated by the red outline) Press the black circles to select the color to edit. Or the Paint Value box can be clciked to select from a gradient.", 280, 40, 390, 75);      
  else if (type==35) text("Paint Enabled, click on an LED Icon to set the color to the current Paint Value color. Click button again when finished.", 280, 40, 390, 75);      
  else if (type==36) text("Click on the desired color on the gradient to select it as the Paint Value color.", 280, 40, 390, 75);      
 else if (type==37) text("CTRL+C Pressed. Frame has been Copied.", 280, 40, 390, 75);      
 else if (type==38) text("CTRL+C Pressed. Frame has been pasted.", 280, 40, 390, 75);      
 else if (type==39) text("Software not compatible with that function. Contact if you have any questions.", 280, 40, 390, 75);    
 else if (type==40) text("Use the external program Motion Coordinates, to create a coordinate file that can be loaded by selecting it from the file browser.", 280, 40, 390, 75);     
 else if (type==41) text("File Saved to your selected location, please close the Load/Save Menu", 280, 40, 390, 75);     
 else if (type==42) text("File Loaded from your selected location, please close the Load/Save Menu", 280, 40, 390, 75);     
  LastHelpNum=type;
}
public void DisplayControlMenu()
{
   
   
   image(ControlMenu, GUIMenus[8].xpos, GUIMenus[8].ypos);
   for (int i=0;i != ControlButtonsA.length;i++)  ControlButtonsA[i].display();    
    int a58dlw = 0;
  
   for (int i=0;i != ControlButtonsA.length;i++)  
  {
   if(ControlButtonsA[i].Selected == true) a58dlw = i;
  }
  
  switch(a58dlw)
  {
   case 0: 
    ControlSlider[0].display();
    ControlSlider[1].display();    
    fill(0);
    textSize(18);
    text("Value: "+ControlSlider[0].Value, ControlSlider[0].xpos - 110, ControlSlider[0].ypos+20);
     textSize(14);   
    text("Sesitivity:", ControlSlider[1].xpos - 70, ControlSlider[1].ypos+10);    
    
    ControlButtonsB[12].display(); 
    break;
 
 case 1: 
  ControlButtonsB[13].display();
  ControlButtonsB[14].display();
  fill(0);
  textSize(14);
  text("Remember to Select the Setting with Stall before trying to Flash Step", GUIMenus[8].xpos+20, GUIMenus[8].ypos+180);
  
  break; 
case 2:
    ControlSlider[0].display();
    ControlSlider[1].display();  
    fill(0);
    textSize(18);
    text("Value: "+ControlSlider[0].Value, ControlSlider[0].xpos - 110, ControlSlider[0].ypos+20);
     textSize(14);   
    text("Sesitivity:", ControlSlider[1].xpos - 70, ControlSlider[1].ypos+10);    
    
    text("A Setting with 3 Frames takes a value of 768 to do a full cycle of the pattern. ", GUIMenus[8].xpos+10, GUIMenus[8].ypos+220);      
    
    ControlButtonsB[12].display(); 
  break;
case 3: 
      for (int i=0;i != 6;i++)  ControlButtonsB[i].display(); 
    ControlButtonsB[12].display(); 
    ControlButtonsB[16].display(); 
    ControlButtonsB[17].display(); 
  break;
 
case 4: 
      for (int i=0;i != 8;i++)  ControlButtonsB[i].display(); 
      
      ControlButtonsB[15].display(); 
      ControlButtonsB[19].display(); 
      ControlButtonsB[12].display();  
      
 if(ControlButtonsB[15].Selected == true)
{
       ControlButtonsB[8].display();
      ControlButtonsB[9].display(); 
       ControlButtonsB[10].display();     
      ControlButtonsB[11].display();  
}
 
      
      textSize(16);
      fill(0);
      text("Setting Number:", ControlButtonsB[0].xpos,ControlButtonsB[0].ypos-10);
  break; 
  
case 5:    
      for (int i=0;i != 8;i++)  ControlButtonsB[i].display(); 
      
      ControlButtonsB[15].display(); 
      ControlButtonsB[19].display(); 
      ControlButtonsB[12].display();  
      
 if(ControlButtonsB[15].Selected == true)
{
       ControlButtonsB[8].display();
      ControlButtonsB[9].display(); 
       ControlButtonsB[10].display();     
      ControlButtonsB[11].display();  
}
 
      
      textSize(16);
      fill(0);
      text("Setting Number:", ControlButtonsB[0].xpos,ControlButtonsB[0].ypos-10);
  break;  
case 6:
    ControlButtonsB[18].display(); 
  break;
  }
}
public void DisplayMultiMenu()
{
  
  image(MultiMenu, GUIMenus[7].xpos, GUIMenus[7].ypos);
  LinkerButtons[22].xpos = GUIMenus[7].xpos+305; 
  LinkerButtons[22].ypos = GUIMenus[7].ypos+50;
  LinkerButtons[21].xpos = GUIMenus[7].xpos+170; 
  LinkerButtons[21].ypos = GUIMenus[7].ypos+260; 
  LinkerButtons[16].xpos = GUIMenus[7].xpos+140;
  LinkerButtons[16].ypos = GUIMenus[7].ypos+50; 
  LinkerButtons[17].xpos = GUIMenus[7].xpos+185;
  LinkerButtons[17].ypos = GUIMenus[7].ypos+50;   
  LinkerButtons[18].xpos = GUIMenus[7].xpos+230;
  LinkerButtons[18].ypos = GUIMenus[7].ypos+50; 
  LinkerButtons[19].xpos = GUIMenus[7].xpos+275;
  LinkerButtons[19].ypos = GUIMenus[7].ypos+50; 
  for (int q=0; q != MultiSliders.length;q++)  
  {
    MultiSliders[q].display();
    fill(SketchGenFontColor);
    textSize(14); 
    text("Repeat: "+MultiSliders[q].Value, GUIMenus[7].xpos+10, GUIMenus[7].ypos+105+(q*50));
  }
  blend(MultiPressed, 0, 0, 35, 35, LinkerButtons[16+SelectedMulti].xpos, LinkerButtons[16+SelectedMulti].ypos, 35, 35, LIGHTEST);  
  DisplayHelp(28);
  
  
  if (LineDraggingLinker==true)
  {
    stroke(LinkerLineColor);
    strokeWeight(2);
    line(LinkerButtons[LineDragNum].xpos+15, LinkerButtons[LineDragNum].ypos+15, mouseX, mouseY);
    for (int i=0;i != 8;i++)
    {
      if (i != LineDragNum && MultiLinkerMap[SelectedMulti][i] != 255)
      {
        stroke(LinkerLineColor);
        strokeWeight(2);
        line(LinkerButtons[i].xpos+25, LinkerButtons[i].ypos+15, LinkerButtons[MultiLinkerMap[SelectedMulti][i]+8].xpos+30, LinkerButtons[MultiLinkerMap[SelectedMulti][i]+8].ypos+15);
      }
    }
  }
  else
  {
    
    for (int i=0;i != 8;i++)
      if (MultiLinkerMap[SelectedMulti][i] != 255)
      {
        stroke(LinkerLineColor);
        strokeWeight(2);
        line(LinkerButtons[i].xpos+25, LinkerButtons[i].ypos+15, LinkerButtons[MultiLinkerMap[SelectedMulti][i]+8].xpos+30, LinkerButtons[MultiLinkerMap[SelectedMulti][i]+8].ypos+15);
      }
  }
  noStroke();
}
public void DisplayLinkerMenu()
{
  
  image(LinkerMenu, GUIMenus[6].xpos, GUIMenus[6].ypos);
  LinkerButtons[22].xpos = GUIMenus[6].xpos+150; 
  LinkerButtons[22].ypos = GUIMenus[6].ypos+50;
  LinkerButtons[21].xpos = GUIMenus[6].xpos+115; 
  LinkerButtons[21].ypos = GUIMenus[6].ypos+105;
  LinkerButtons[16].xpos = GUIMenus[6].xpos+130;
  LinkerButtons[16].ypos = GUIMenus[6].ypos+340; 
  LinkerButtons[17].xpos = GUIMenus[6].xpos+175;
  LinkerButtons[17].ypos = GUIMenus[6].ypos+340;   
  LinkerButtons[18].xpos = GUIMenus[6].xpos+130;
  LinkerButtons[18].ypos = GUIMenus[6].ypos+385; 
  LinkerButtons[19].xpos = GUIMenus[6].xpos+175;
  LinkerButtons[19].ypos = GUIMenus[6].ypos+385; 
  
  
  if (LineDraggingLinker==true)
  {
    stroke(LinkerLineColor);
    strokeWeight(2);
    line(LinkerButtons[LineDragNum].xpos+15, LinkerButtons[LineDragNum].ypos+15, mouseX, mouseY);
    for (int i=0;i != 8;i++)
      if (i != LineDragNum && LinkerMap[i] != 255)
      {
        stroke(LinkerLineColor);
        strokeWeight(2);
        if (LinkerMap[i]==12)
        {
          line(LinkerButtons[i].xpos+25, LinkerButtons[i].ypos+15, LinkerButtons[20].xpos+40, LinkerButtons[20].ypos+15);
        }
        else    
          line(LinkerButtons[i].xpos+25, LinkerButtons[i].ypos+15, LinkerButtons[LinkerMap[i]+8].xpos+15, LinkerButtons[LinkerMap[i]+8].ypos+15);
      }
  }
  else
  {
    
    for (int i=0;i != LinkerMap.length;i++)
      if (LinkerMap[i] != 255)
      {
        stroke(LinkerLineColor);
        strokeWeight(2);
        if (LinkerMap[i]==12)
        {
          line(LinkerButtons[i].xpos+25, LinkerButtons[i].ypos+15, LinkerButtons[20].xpos+40, LinkerButtons[20].ypos+15);
        }   
        else
          line(LinkerButtons[i].xpos+25, LinkerButtons[i].ypos+15, LinkerButtons[LinkerMap[i]+8].xpos+15, LinkerButtons[LinkerMap[i]+8].ypos+15);
      }
  }
  noStroke();
}
public void DisplayHardwareInfo()
{
  
  fill(SketchGenFontColor);
  textSize(16);
  text("Available Frames: "+(DeviceMaxFrames-TotalFrames), 800, 30);
  text("Device Channels: "+LEDChanTotal, 800, 50);  
  text("Device RGB Channels: "+LEDChanTotal/3, 800, 70);    
  text("Max LEDs/Channel: "+DeviceMaxPerChan, 800, 90); 
  for (int i=0; i != Buttons.length;i++) Buttons[i].display();
}
public void DisplayLiveModeMenu()
{
  image(LiveModeMenu, GUIMenus[5].xpos, GUIMenus[5].ypos);
  for (int q=0; q != LiveModeButtons.length;q++) LiveModeButtons[q].display();
  if (LiveModeGradientOpen==true)
  {
    image(LiveModeGradient, GUIMenus[5].xpos+65, GUIMenus[5].ypos+60); 
    return;
  }
  textSize(12);
  for (int i=0; i != LEDChanTotal;i++) 
  {
    fill(SketchGenFontColor);
    text("Chan "+(i+1)+":", LiveModeSliders[i].xpos-55, LiveModeSliders[i].ypos+10);
    LiveModeSliders[i].display();
  }
}
public void DisplaySaveLoadMenu()
{
  image(SaveLoadMenu, GUIMenus[4].xpos, GUIMenus[4].ypos);  
  for (int q=0; q != SaveLoadButtons.length;q++) SaveLoadButtons[q].display();
  if (SaveConfirm==true)
  {
    image(ConfirmBox, 300, 300);
    textSize(16);
    fill(SketchGenFontColor);
    text(PrevString[4], 470, 392); 
    text(PrevString[3], 470, 412); 
    text(PrevString[1], 470, 432); 
    text(PrevString[6], 470, 450); 
  }
}
public void DisplayOffsetMenu() 
{
  GUIMenus[0].display(); 
  
  image(OffsetMenu, GUIMenus[3].xpos, GUIMenus[3].ypos);
  for (int i=0;i < OffsetButtons.length; i++)  OffsetButtons[i].display();
  for (int i=0; i != ColorSlider.length;i++) ColorSlider[i].display();
  
  textSize(16);
  fill(SketchGenFontColor);
  noStroke();
  text(ColorSlider[0].Value, GUIMenus[3].xpos+75, GUIMenus[3].ypos+65);
  text(ColorSlider[1].Value, GUIMenus[3].xpos+75, GUIMenus[3].ypos+85);
  text(ColorSlider[2].Value, GUIMenus[3].xpos+75, GUIMenus[3].ypos+105);
  text(ColorSlider[3].Value, GUIMenus[3].xpos+75, GUIMenus[3].ypos+45);
  
  int tempQ=450 / OffsetMaxFrames[var3345aj];
  for (int i = 0; i != OffsetMaxFrames[var3345aj];i++) 
  {
    if (i == (OffsetMaxFrames[var3345aj]-1)) 
      setGradient(GUIMenus[3].xpos+230+(i*tempQ), GUIMenus[3].ypos+50, tempQ, 50, var993za[var3345aj][i], var993za[var3345aj][0]);    
    else
      setGradient(GUIMenus[3].xpos+230+(i*tempQ), GUIMenus[3].ypos+50, tempQ, 50, var993za[var3345aj][i], var993za[var3345aj][i+1]);
  }
  text("Channel Start Offset:", GUIMenus[3].xpos+80, GUIMenus[3].ypos+120);
  for (int i=0; i != (LEDChanTotal/3);i++) 
  {
    if ((LEDChanTotal/3) == ColorSlider[3].Value)
    {
      
      image(PointMark, GUIMenus[3].xpos+230+(i*(450/(LEDChanTotal/3))), GUIMenus[3].ypos+87);
      text(i+1, GUIMenus[3].xpos+230+(i*(450/(LEDChanTotal/3))), GUIMenus[3].ypos+120);
    }
    else
    {
      image(PointMark, GUIMenus[3].xpos+230+(i*(450/ (ColorSlider[3].Value))), GUIMenus[3].ypos+87);
      text(i+1, GUIMenus[3].xpos+230+(i*(450/ (ColorSlider[3].Value))), GUIMenus[3].ypos+120);
    }
  }
  for (int i=0; i != OffsetMaxFrames[var3345aj];i++)
  {
    fill(var993za[var3345aj][i]);
    if (i == OffsetSelectedFrame)
    {
      strokeWeight(2); 
      stroke((255 - red(var993za[var3345aj][i])), (255 - green(var993za[var3345aj][i])), (255 - blue(var993za[var3345aj][i]))); 
    }
    rect(GUIMenus[3].xpos+50+(i*40), GUIMenus[3].ypos+125, 30, 30);
    noStroke();
  }
}
public void DisplaySettingInfo()  
{
  
  
  if (SettingFrames[var3345aj][SelectedFrame].SlideValue==127 && GlobalDragging==false)
    SlideFrameSliders[var3345aj].Value=1; 
  else if (SettingFrames[var3345aj][SelectedFrame].SlideValue != 127 && GlobalDragging==false)
  {
    SlideFrameSliders[var3345aj].Value = SettingFrames[var3345aj][SelectedFrame].SlideValue;
  }
  image(SettingsInfo, GUIMenus[2].xpos, GUIMenus[2].ypos);
  fill(SketchGenFontColor);
  textSize(18);
  text("Setting "+(var3345aj+1), 910, 542);
  textSize(16);
  text("Frame: "+(SelectedFrame+1)+" - LED:"+(SelectedLED+1), 885, 625);
  textSize(14);
  noStroke();
  fill(0); 
  ellipse(890, 685, 12, 12);  
  ellipse(890, 700, 12, 12);  
  ellipse(890, 715, 12, 12);  
  fill(SketchGenFontColor); 
    switch(SettingInfoColSelect)
  {
  case 0:
    text("Red Select:", 890, 735);
    fill(255, 0, 0);
    ellipse(890, 685, 12, 12);  
    if (EditPaintValue == true) GreyValueSliders[var3345aj].Value = (int)red(PaintValue);
    else GreyValueSliders[var3345aj].Value = GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)];
    break;
  case 1:
    text("Green Select:", 890, 735);
    fill(0, 255, 0);
    ellipse(890, 700, 12, 12);  
    if (EditPaintValue == true) GreyValueSliders[var3345aj].Value = (int)green(PaintValue);
    else GreyValueSliders[var3345aj].Value = GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+1];
    break;
  case 2:
    text("Blue Select:", 890, 735);
    fill(0, 0, 255);
    ellipse(890, 715, 12, 12);  
    if (EditPaintValue == true) GreyValueSliders[var3345aj].Value = (int)blue(PaintValue);
    else GreyValueSliders[var3345aj].Value = GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+2];
    break;
  }
  fill(SketchGenFontColor);
  text("Speed: "+SpeedSliders[var3345aj].Value, 890, 560); 
  textSize(12); 
  text("Amount: "+SlideFrameSliders[var3345aj].Value, 885, 670);
  SlideFrameSliders[var3345aj].display();
  noStroke();   
  if (SettingFrames[var3345aj][SelectedFrame].SlideUpDown == 0)
  {
    fill(SketchBGColor, 128);
    rect(885, 660, 200, 20);
  }
  float myRed;
  float myGreen;
  float myBlue;
  if (EditPaintValue == true)
  {
    strokeWeight(6);
    fill(0, 0, 0, 0); 
    stroke(255, 0, 0);
    rect(875, 660, 150, 105);
    noStroke();
    myRed = red(PaintValue);
    myGreen = green(PaintValue);
    myBlue = blue(PaintValue);
    fill(PaintValue);
  }
  else
  {
    myRed = GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)];
    myGreen = GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+1];
    myBlue = GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+2];
    fill(myRed, myGreen, myBlue);
  }
  stroke(0);
  strokeWeight(1);
  rect(980, 680, 35, 35); 
  noStroke();
  fill(SketchGenFontColor); 
  textSize(14);
  textLeading(14);
  text("Red: "+(int)myRed+"\nGreen: "+(int)myGreen+"\nBlue: "+(int)myBlue, 900, 690);
  SettInfoButtons[var3345aj][0].display(); 
  SettInfoButtons[var3345aj][1].display(); 
  SettInfoButtons[var3345aj][2].display(); 
  SettInfoButtons[var3345aj][3].display(); 
  SettInfoButtons[var3345aj][4].display(); 
  SettInfoButtons[var3345aj][5].display(); 
  SpeedSliders[var3345aj].display(); 
  GreyValueSliders[var3345aj].display();
}
public void Refresh()  
{
  
  background(SketchBGColor);
  image(BackGround, 0, 0);
  for (int i=0;i < COMButtons.length; i++) COMButtons[i].display();
  
  for (int i=0;i != RSideButtons.length;i++) RSideButtons[i].display();  
  for (int i=0;i != LSideButtons.length;i++) LSideButtons[i].display();  
  GUIMenus[var37ad3].display();
  DisplayHelp(LastHelpNum);
  DisplayHardwareInfo();
  noStroke();
  textSize(18);
  fill(SketchGenFontColor);
  textSize(18);
  text("Device Status: "+DevStatus, 20, 10, 240, 140);
  text("Select COM Port: "+portName, 15, 40, 240, 100);  
  textSize(14);
  text("Device: "+DeviceName+", "+DeviceFirmware, 285, 13, 440, 440);
}
public void FrameButtonsDisplay()  
{
  
  
  fill(SketchBGColor);
  noStroke();
  rect(135, 590, 730, 120);
  for (int i=0;i != UserSettings[var3345aj].FrameLength;i++) 
  {
    AddFrameButtons[i].display();
  }
  if (UserSettings[var3345aj].OffsetEnable==true)
  {
    
    fill(SketchBGColor, 128);
    rect(135, 590, 730, 120);
  }
  WorkSpaceButtons[3].Selected = UserSettings[var3345aj].OffsetEnable;  
  for (int i=0;i != WorkSpaceButtons.length;i++)   WorkSpaceButtons[i].display();
  if (WorkSpaceButtons[5].Selected == true) 
  {
    stroke(255, 0, 0);
    strokeWeight(4);
    rect(WorkSpaceButtons[5].xpos, WorkSpaceButtons[5].ypos, 30, 30);
  }
}
public void DisplayConfigMenu() 
{  
  
  
  image(ConfigMenuImg, GUIMenus[1].xpos, GUIMenus[1].ypos);
  
  
  
  String DisplayText="LED Total";
  
  if (LEDChanTotal <= DotCorrection.length)
  {
    if (ConfigFuncButtons[5].Selected == true)
    {
      ConfigFuncButtons[6].display();
      for (int q=0; q != LEDChanTotal;q++) 
      {
        DotCorrection[q].display();
        fill(SketchGenFontColor);
        textSize(12);
        text("Chan "+(q+1)+":", DotCorrection[q].xpos-50, DotCorrection[q].ypos+10);
      }
      DisplayText= "Dot Correction Slider Value";
    }
  }
  else
  {
    DisplayHelp(39);
  }
  if (ConfigFuncButtons[5].Selected == false) 
  {
    if (ConfigSliders[0].Value != 0)
    {
      for (int i=0;i != (ConfigSliders[0].Value); i++) 
      {
        LEDIcon[i].display();
      }
    } 
    ConfigSliders[0].display();
  }  
  
  fill(SketchBGColor);
  noStroke();
  rect(ConfigSliders[0].xpos-85, ConfigSliders[0].ypos, 75, ConfigSliders[0].Slheight);       
  textSize(18);
  fill(SketchGenFontColor);
  if (ConfigFuncButtons[5].Selected == false) text(DisplayText+": "+ConfigSliders[0].Value, ConfigSliders[0].xpos-120, ConfigSliders[0].ypos+20);  
  else  text(DisplayText+": "+DotCorrection[SelectedSlider].Value, ConfigSliders[0].xpos-95, ConfigSliders[0].ypos+20);  
  textSize(12);
  text("Some Devices can handle more LEDs per channel, but unsupported by the software.", 270, 715);
} 
public void LEDShapeBuild()
{
  
  
  
  switch(ConfigShape)
  {
  case 1:
    BuildRound();
    break;
  case 2:
    BuildSquare();      
    break;
  case 3:
    BuildRect();      
    break;
  case 4:
    BuildSpiral();      
    break;    
  case 5:
    BuildLine();      
    break; 
  case 6:
    BuildCustom();      
    break;
  }
}
public void BuildRound()
{
  float degreeChange = (float)360 / (ConfigSliders[0].Value);
  float Angle=0;
  try
  {
    LEDsPerChan = ConfigSliders[0].Value / (LEDChanTotal/3);
  }
  catch(Exception e)
  {
    LEDsPerChan =1;
  }
  int LEDIconIDCounter=0;
  for (int i=0;i != ConfigSliders[0].Value ; i++)
  { 
    LEDFillColor(i);
    
    double Xa = centX+ShapeSize*Math.sin(Angle*Math.PI/180);
    double Ya = centY+ShapeSize*-Math.cos(Angle*Math.PI/180);
    Angle = Angle + degreeChange; 
    LEDIcon[i] = new LEDgraphic(temp, (int)Xa, (int)Ya, LEDSize, color(255)); 
  }
}
public void BuildSquare()
{
  if (ConfigSliders[0].Value == 0) return;
  int holdSS = ShapeSize;
  ShapeSize = round(ShapeSize *2);
  float Spacing = ShapeSize / ((float)ConfigSliders[0].Value/4);
  int LEDCounter=0;
  
  for (int i=0;i != (ConfigSliders[0].Value/4);i++)
  {
    LEDFillColor(LEDCounter);      
    LEDIcon[LEDCounter] = new LEDgraphic(temp, (int)round((centX-(ShapeSize/2))+(Spacing/2)+(Spacing*i)), centY+(ShapeSize/2), LEDSize, color(255));
    LEDCounter++;
  }
  
  for (int i=0;i!=(ConfigSliders[0].Value/4);i++)
  {
    LEDFillColor(LEDCounter);  
    LEDIcon[LEDCounter] = new LEDgraphic(temp, (centX+(ShapeSize/2)), (int)round((centY+(ShapeSize/2))-(Spacing/2)-(Spacing*i)), LEDSize, color(255));
    LEDCounter++;
    
  }
  
  for (int i=0;i!=(ConfigSliders[0].Value/4);i++)
  {
    LEDFillColor(LEDCounter);      
    LEDIcon[LEDCounter] = new LEDgraphic(temp, (int)round((centX+(ShapeSize/2))-(Spacing/2)-(Spacing*i)), (centY-(ShapeSize/2)), LEDSize, color(255));
    LEDCounter++;
  }
  
  for (int i=0;i!=(ConfigSliders[0].Value/4);i++)
  { 
    LEDFillColor(LEDCounter);  
    LEDIcon[LEDCounter] = new LEDgraphic(temp, centX-(ShapeSize/2), (int)round((centY-(ShapeSize/2))+(Spacing/2)+(Spacing*i)), LEDSize, color(255));
    LEDCounter++;
  }
  ShapeSize = holdSS; 
}
public void BuildSpiral()
{
  int LEDCounter=0; 
  radius = 120;
  
  iterationcounter = 0;
  for (float theta = chord / awayStep; theta <= thetaMax; ) 
  {
    
    if (iterationcounter == ConfigSliders[0].Value) return;
    
    float away = awayStep * theta;
    
    float around = theta + rotation;
    
    int x = (int)round(centX + cos( around ) * away);
    int y = (int)round(centY + sin( around ) * away);
    
    LEDFillColor(LEDCounter);  
    LEDIcon[LEDCounter] = new LEDgraphic(temp, (int)x, (int)y, LEDSize, color(255)); 
    LEDCounter++;
    
    
    theta += chord / away;
    iterationcounter++;
  } 
  ConfigSliders[0].Value = iterationcounter;
} 
public void BuildLine()
{
  if (ConfigSliders[0].Value == 0) return;
  int holdSS = ShapeSize;
  ShapeSize = round(ShapeSize *2.75f);
  float Spacing = ShapeSize / ((float)ConfigSliders[0].Value);
  int LEDCounter=0;
  for (int i=0;i!=(ConfigSliders[0].Value);i++)
  {
    LEDFillColor(LEDCounter);      
    LEDIcon[LEDCounter] = new LEDgraphic(temp, (int)round((centX+(ShapeSize/2))-(Spacing/2)-(Spacing*i)), (centY-(ShapeSize/4)), LEDSize, color(255));
    LEDCounter++;
  } 
  ShapeSize = holdSS; 
}
public void LEDFillColor(int i)
{
  temp = i%(LEDChanTotal/3);
  return;
}
public void BuildRect()
{
  
  
  DisplayHelp(24);
}
public void BuildCustom()
{
  
  
  
  String[] lines = loadStrings(SelectedLocation); 
  int sLines=0;  
  String[] WorkString = new String[3]; 
  WorkString = split(lines[0], '\t');
  int HoldChannelAmount = PApplet.parseInt(WorkString[0]);
  int HoldTotalAmount = PApplet.parseInt(WorkString[1]);
  boolean HoldMethod = false;
  if (PApplet.parseBoolean(WorkString[2]) == true) HoldMethod = true;
  ConfigSliders[0].Maximum=HoldTotalAmount ;  
  ConfigSliders[0].Value=HoldTotalAmount ;  
  int MinX=1000;
  int MinY=1000;
  int MaxX=0;
  int MaxY=0;
  for (int i=1;i != lines.length;i++)
  {
    WorkString = split(lines[i], '\t');
    if (PApplet.parseInt(WorkString[0]) > MaxX) MaxX = PApplet.parseInt(WorkString[0]);
    if (PApplet.parseInt(WorkString[0]) < MinX) MinX = PApplet.parseInt(WorkString[0]);
    if (PApplet.parseInt(WorkString[1]) > MaxX) MaxY = PApplet.parseInt(WorkString[1]);
    if (PApplet.parseInt(WorkString[1]) < MinY) MinY = PApplet.parseInt(WorkString[1]);
  }
  
  
  int Xdifference = MaxX - MinX;
  int Ydifference = MaxY - MinY;
  
  int tSize =round( (ShapeSize / Xdifference) * 1.5f);
  int XOffset = (tSize * Xdifference)/2;
  if (HoldMethod == true)
  {
    
    for (int i=0;i != HoldTotalAmount;i++)
    {
      WorkString = split(lines[i+1], '\t');
      LEDFillColor(i); 
      LEDIcon[i] = new LEDgraphic(temp, (centX - XOffset) + ((PApplet.parseInt(WorkString[0])-MinX) * tSize), (centY- XOffset) +((PApplet.parseInt(WorkString[1])-MinY) * tSize), LEDSize, color(255));
    }
  }
  else
  {
    
    for (int i=0;i != HoldChannelAmount;i++)
    {
      for (int q=0;q != (HoldTotalAmount/HoldChannelAmount);q++)
      {
        WorkString = split(lines[(i*(HoldTotalAmount/HoldChannelAmount))+q+1], '\t');
        LEDFillColor(i); 
        LEDIcon[(i*(HoldTotalAmount/HoldChannelAmount))+q] = new LEDgraphic(temp, (centX - XOffset) + ((PApplet.parseInt(WorkString[0])-MinX) * tSize), (centY- XOffset) +((PApplet.parseInt(WorkString[1])-MinY) * tSize), LEDSize, color(255));
      }
    }
  }
}
public void GUIPressControl()
{
  
  for (int i=0;i != ControlButtonsA.length;i++)  
  {
    if (ControlButtonsA[i].over())
    {
      for (int x=0;x != ControlButtonsA.length;x++)  ControlButtonsA[x].Selected = false;
      ControlButtonsA[i].Selected =! ControlButtonsA[i].Selected;
    }
  }
  
  int a58dlw = 0;
  int a58dlwB = 0;
  
  for (int i=0;i != ControlButtonsA.length;i++)  
  {
    if (ControlButtonsA[i].Selected == true) a58dlw = i;
  }
  for (int i=0;i != 12;i++)  
  {
    if (ControlButtonsB[i].Selected == true) a58dlwB = i;
  }
  switch(a58dlw)
  {
  case 0: 
    if (ControlSlider[0].over())
    {
      SliderSet=8;
      SelectedSlider=0;
      ControlSlider[0].Dragging=true;
      GlobalDragging=true;
    }
    
    if (ControlSlider[1].over())
    {
      SliderSet=8;
      SelectedSlider=1;
      ControlSlider[1].Dragging=true;
      GlobalDragging=true;
    }  
  
   if(ControlButtonsB[12].over()) 
   {  
  SendRequest(); 
  CmdByte=70;
  DataByte1=(byte)((ControlSlider[0].Value >> 8) & 0xFF);
  DataByte2=(byte)(ControlSlider[0].Value & 0xFF);
  
   }
    break;
  case 1: 
    if(ControlButtonsB[13].over())
    {
     
     ControlButtonsB[13].Selected = true;     
     ControlButtonsB[13].display();
  SendRequest(); 
  CmdByte=82;
  DataByte1=0;
  DataByte2=0;
    }
    else if(ControlButtonsB[14].over())
    {
     
     ControlButtonsB[14].Selected = true;
      ControlButtonsB[14].display();    
      
  SendRequest(); 
  CmdByte=82;
  DataByte1=1;
  DataByte2=0;
    }
    break; 
  case 2:
    if (ControlSlider[0].over())
    {
      SliderSet=8;
      SelectedSlider=0;
      ControlSlider[0].Dragging=true;
      GlobalDragging=true;
    }
    if (ControlSlider[1].over())
    {
      SliderSet=8;
      SelectedSlider=1;
      ControlSlider[1].Dragging=true;
      GlobalDragging=true;
    }
   if(ControlButtonsB[12].over()) 
   {
  SendRequest(); 
  CmdByte=85;
  DataByte1=(byte)((ControlSlider[0].Value >> 8) & 0xFF);
  DataByte2=(byte)(ControlSlider[0].Value & 0xFF);
  
   }
    break;
  case 3: 
    for (int i=0;i != 7;i++)
  {
    if(ControlButtonsB[i].over())
    {
          for (int x=0;x != 8;x++)  ControlButtonsB[x].Selected = false;
          ControlButtonsB[i].Selected =! ControlButtonsB[i].Selected;
         ControlButtonsB[i].display();
      }
    }
  
  
    if(ControlButtonsB[16].over()) 
  {
   ControlButtonsB[16].Selected = true;
   ControlButtonsB[16].display();
   
  SendRequest(); 
  CmdByte=99;
  DataByte1=0;
  DataByte2=0;     
  }
  
  
    if(ControlButtonsB[17].over()) 
  {
   ControlButtonsB[17].Selected = true;
   ControlButtonsB[17].display();    
   
  SendRequest(); 
  CmdByte=99;
  DataByte1=0;
  DataByte2=1;     
  }  
  
   if(ControlButtonsB[12].over()) 
   { 
   SendRequest(); 
  CmdByte=99;
  DataByte1 = a58dlwB+1; 
  DataByte2 = 0;     
   }
    break;
  case 4: 
  int TempA = 8;
  
  if(ControlButtonsB[15].Selected == true) TempA = 12;
           
    for (int i=0;i != TempA;i++)
  {
    if(ControlButtonsB[i].over())
    {
               for (int x=0;x != 12;x++) ControlButtonsB[x].Selected = false;
              ControlButtonsB[i].Selected =! ControlButtonsB[i].Selected;
              ControlButtonsB[i].display();
    }
   }
    if(ControlButtonsB[12].over())
    {
          
          SendRequest(); 
          if(ControlButtonsB[15].Selected ==false) CmdByte=81; 
          else CmdByte=80;
          
          
          
          DataByte1=a58dlwB;
          DataByte2=0;       
    }
   
    if(ControlButtonsB[19].over())
    {
           SendRequest(); 
           CmdByte=80;
          DataByte1=33;
          DataByte2=0;      
    }
   
     if(ControlButtonsB[15].over())
    {  
    ControlButtonsB[15].Selected =! ControlButtonsB[15].Selected;
    }
    break; 
  case 5:    
     TempA = 8;
  
  if(ControlButtonsB[15].Selected == true) TempA = 12;
           
    for (int i=0;i != TempA;i++)
  {
    if(ControlButtonsB[i].over())
    {
               for (int x=0;x != 12;x++) ControlButtonsB[x].Selected = false;
              ControlButtonsB[i].Selected =! ControlButtonsB[i].Selected;
              ControlButtonsB[i].display();
    }
   }
   
    if(ControlButtonsB[12].over())
    {
          
          SendRequest(); 
          if(ControlButtonsB[15].Selected == false) CmdByte=224;
          else CmdByte=220;
          
          DataByte1=a58dlwB;
          DataByte2=0;       
    }
   
    if(ControlButtonsB[19].over())
    {
          SendRequest(); 
          CmdByte=220;
          DataByte1=33;
          DataByte2=0;      
    }
   
     if(ControlButtonsB[15].over())
    {  
    ControlButtonsB[15].Selected =! ControlButtonsB[15].Selected;
    }
    break;
  case 6: 
  ControlButtonsB[18].Selected =! ControlButtonsB[18].Selected;
  ControlButtonsB[18].display();
  
   if(ControlButtonsB[18].over()) 
   { 
   SendRequest(); 
  CmdByte = 62;
  DataByte1 = 0;
  DataByte2 = 0;     
   }
   break;   
  }
}
public void GUIPressMulti()
{
  
  for (int q=0; q != MultiSliders.length;q++)  
  {
    if (MultiSliders[q].over())
    {
      
      SliderSet=6;
      SelectedSlider=q;
      MultiSliders[q].Dragging=true;
      GlobalDragging=true;
    }
  }
  
  for (int i=0;i != LinkerButtons.length;i++) 
  {
    if (LinkerButtons[i].over() && i != 20)
    {
      
      if (i < 8)
      {
        LineDragNum=i;
        LineDraggingLinker=true;
      }
      else if (i > 7 && i < 20)
      {  
        if (LineDraggingLinker==true)
        {
          LineDraggingLinker=false;
          MultiLinkerMap[SelectedMulti][LineDragNum] = (i-8);
        }
      }
      if (i==22 && LineDraggingLinker == false)
      {
        
        
      }
      else if (i==21 && LineDraggingLinker == false)
      {
        
        for (int q=0; q != 8;q++) MultiLinkerMap[SelectedMulti][q] = 255; 
      } 
      else if (i > 15  && i < 20)
      { 
        LinkerButtons[16].Selected=false;
        LinkerButtons[17].Selected=false;    
        LinkerButtons[18].Selected=false;
        LinkerButtons[19].Selected=false;
        LinkerButtons[i].Selected =! LinkerButtons[i].Selected;
        blend(MultiPressed, 0, 0, 35, 35, LinkerButtons[i].xpos, LinkerButtons[i].ypos, 35, 35, LIGHTEST);  
        SelectedMulti = i-16;
      }
    }
  }
}
public void GUIPressLinker()
{
  
  for (int i=0;i != LinkerButtons.length;i++) 
  {
    if (LinkerButtons[i].over())
    {
      
      if (i < 8)
      {
        LineDragNum=i;
        LineDraggingLinker=true;
      }
      else if (i > 7 && i < 20)
      {
        if (LineDraggingLinker==true)
        {
          LineDraggingLinker=false;
          if (i < 21) LinkerMap[LineDragNum]=(i-8); 
        }
      }
      if (i==22 && LineDraggingLinker == false)
      {
        
        StartSettingsUpload();
      }
      else if (i==21 && LineDraggingLinker == false)
      {
        
        for (int q=0; q != 8;q++)LinkerMap[q]=255;
      }
      else if (i==20)
      {
        
        LineDraggingLinker=false;
        LinkerMap[LineDragNum]=12; 
      }
    }
  }
}
public void GUIPressLiveMode() 
{
  for (int i=0; i != LiveModeButtons.length;i++) 
  {
    if (LiveModeButtons[i].over())
    { 
      LiveModeButtons[i].Selected =! LiveModeButtons[i].Selected;
      LiveModeButtons[i].display();    
      switch(i)
      {
      case 0:
        LiveModeGradientOpen =! LiveModeGradientOpen;
        SelectedSlider=0;
        break;
      case 1:
        
        LiveModeButtons[1].Selected=true;       
        LiveModeButtons[2].Selected=false;
        
        frameRate(30);
        ToggleLiveMode(1);
        break;    
      case 2:
        
        LiveModeButtons[1].Selected=false;  
        LiveModeButtons[2].Selected=true;   
        
        frameRate(15);
        ToggleLiveMode(0);
        break;
      }
      GUIMenus[var37ad3].display();
      return;
    } 
  }
  if (LiveModeGradientOpen == true)
  {
    int myColor=get(mouseX, mouseY);
    image(PointMark, mouseX-6, mouseY-6);
    
    
    if (SelectedSlider < LEDChanTotal)
    {
      LiveModeSliders[SelectedSlider].Value = (int)red(myColor);
      LiveModeSliders[SelectedSlider+1].Value = (int)green(myColor);  
      LiveModeSliders[SelectedSlider+2].Value = (int)blue(myColor);
      SelectedSlider=SelectedSlider+3;
    }
    else 
    {
      SelectedSlider = 0;
      LiveModeSliders[SelectedSlider].Value = (int)red(myColor);
      LiveModeSliders[SelectedSlider+1].Value = (int)green(myColor);  
      LiveModeSliders[SelectedSlider+2].Value = (int)blue(myColor);  
      SelectedSlider=SelectedSlider+3;
    }
    SendLive(4);
    return;
  }
  for (int i=0; i != LEDChanTotal;i++) 
  {  
    if (LiveModeSliders[i].over())
    {
      SliderSet=5;
      SelectedSlider=i;
      LiveModeSliders[i].Dragging=true;
      GlobalDragging=true;
    }
  }
}
public void GUIPressSaveLoad()
{
  
  if (SaveConfirm==true)
  {
    if (mouseX > 345 && mouseX < 460)
    {
      if (mouseY > 340 && mouseY <365)
      {
        
        
        if (SaveOrLoad==true)
        {
          SaveUserConfigs(SelectedLocation);
        }
        else
        {
          LoadUserConfigs(SelectedLocation);     
          GUIMenus[4].Toggle();
          LSideButtons[3].Selected = GUIMenus[4].Opened;   
          if (GUIMenus[4].Opened) DisplayHelp(22);
          
        }        
        SaveConfirm=false;
        return;
      }
    }        
    if (mouseX > 520 && mouseX < 640)
    {
      if (mouseY > 340 && mouseY <365)
      {
        
        SaveConfirm=false;
        return;
      }
    }
  }
  else
  {
    for (int i=0; i != SaveLoadButtons.length;i++) 
    {
      if (SaveLoadButtons[i].over())
      {
        
        SaveLoadButtons[i].Selected=true;
        SaveLoadButtons[i].display();
        if (i == 12)
        {
          
          
          
          
          
          FileBrowserAction = 2;
          selectOutput("Select a file to Save:", "fileSelected");
          return;
        }
        if ( i==13)
        {
          FileBrowserAction = 3;
          selectInput("Select a file to Load:", "fileSelected");
          return;
        }
        if (i < 6)
        {
          
          SelectedLocation = SaveLocs[i];
          
          SaveOrLoad=true;
          SaveConfirm=true;
          LoadSavePreview(SelectedLocation);
        }
        else if (i > 5)
        {
          
          
          SaveOrLoad =false;
          SaveConfirm=true;
          SelectedLocation = SaveLocs[i-6];
          LoadSavePreview(SelectedLocation);
        }     
        
        
      }
    }
  }
}
public void GUIPressOffsetMenu() 
{
  
  if (OffsetButtons[0].over())
  {
    OffsetButtons[0].Selected = true;
    OffsetButtons[0].display();    
    Func01();
  } 
  if (OffsetButtons[1].over())
  {
    
    OffsetButtons[1].Selected = true;
    OffsetButtons[1].display();  
    if (OffsetMaxFrames[var3345aj] != 1) OffsetMaxFrames[var3345aj]--;
    UserSettings[var3345aj].FrameLength = OffsetMaxFrames[var3345aj];   
    TotalFrames=0;  
    for (int q=0; q != UserSettings.length;q++) TotalFrames = TotalFrames + UserSettings[q].FrameLength;
  }
  if (OffsetButtons[2].over())
  {
    
    OffsetButtons[2].Selected = true;
    OffsetButtons[2].display();  
    UserSettings[var3345aj].FrameLength = OffsetMaxFrames[var3345aj];   
    TotalFrames=0;  
    for (int q=0; q != UserSettings.length;q++) TotalFrames = TotalFrames + UserSettings[q].FrameLength;          
    if (OffsetMaxFrames[var3345aj] != 16 && TotalFrames != DeviceMaxFrames) OffsetMaxFrames[var3345aj]++;
    else DisplayHelp(14);
  } 
  if (OffsetButtons[3].over())
  {
    
    OffsetButtons[3].Selected = true;
    OffsetButtons[3].display();  
    var37ad3=0;
    GUIMenus[var37ad3].display();
    return;
  }    
  for (int i=0; i != ColorSlider.length;i++)   
    if (ColorSlider[i].over()) 
    {
      SliderSet=3;
      SelectedSlider=i;
      ColorSlider[i].Dragging=true;
      GlobalDragging=true;
    }
  for (int i=0; i != OffsetMaxFrames[var3345aj];i++)
  {
    if (mouseX >= GUIMenus[3].xpos+50+(i*40) && mouseX <= GUIMenus[3].xpos+80+(i*40))
    {
      if (mouseY >= GUIMenus[3].ypos+125 && mouseY <= GUIMenus[3].ypos+155)  
      {  
        OffsetSelectedFrame = i;
        ColorSlider[0].Value = (int)red(var993za[var3345aj][i]);
        ColorSlider[1].Value = (int)green(var993za[var3345aj][i]);
        ColorSlider[2].Value = (int)blue(var993za[var3345aj][i]);
      }
    }
  }
  
}
public void GUISettingsInfo() 
{
  
  if (mouseX >= 885 && mouseX <= 930)
  {
    if (mouseY >= 680 && mouseY <= 695) SettingInfoColSelect=0;
    else if (mouseY >= 695 && mouseY <= 710) SettingInfoColSelect=1;  
    else if (mouseY >= 710 && mouseY <= 725) SettingInfoColSelect=2; 
    
  }
  if (UserSettings[var3345aj].FadeFlash==true) 
  { 
    if (SettInfoButtons[var3345aj][4].over()) 
    {     
      UserSettings[var3345aj].ForwardReverse=1;
      FigureSettingsButtons();
      return;
    }
    if (SettInfoButtons[var3345aj][5].over()) 
    {     
      UserSettings[var3345aj].ForwardReverse=0;
      FigureSettingsButtons();
      return;
    }
  }
  else DisplayHelp(30); 
  if (UserSettings[var3345aj].OffsetEnable == false)
  {
    if (SettInfoButtons[var3345aj][0].over())
    { 
      
      UserSettings[var3345aj].FadeFlash=false;
    }
    if (SettInfoButtons[var3345aj][1].over() && UserSettings[var3345aj].OffsetEnable != true)
    {
      
      UserSettings[var3345aj].FadeFlash=true;
    }
    if (SettInfoButtons[var3345aj][2].over())
    {
      AlterSlide(true);
    } 
    if (SettInfoButtons[var3345aj][3].over())
    {
      AlterSlide(false);
    }  
    FigureSettingsButtons();
  }
  else DisplayHelp(18);  
  if (SpeedSliders[var3345aj].over())
  {
    
    SelectedSlider=var3345aj;
    SliderSet=0;
    SpeedSliders[var3345aj].Dragging=true;
    GlobalDragging=true;
  }
  else if (GreyValueSliders[var3345aj].over() && UserSettings[var3345aj].OffsetEnable == false)  
  {
    
    SelectedSlider=var3345aj;
    GreyValueSliders[var3345aj].Dragging=true;
    SliderSet=1;
    GlobalDragging=true;
  }
  else if (SlideFrameSliders[var3345aj].over() && SettingFrames[var3345aj][SelectedFrame].SlideUpDown != 0) 
  {
    
    SelectedSlider=var3345aj;
    SlideFrameSliders[var3345aj].Dragging=true;
    SliderSet=2;
    GlobalDragging=true;
  }
}
public void GUIPressNoMenu() 
{
  
  
  for (int i=0;i != ConfigSliders[0].Value;i++)
  { 
    if (LEDIcon[i].over())
    {
      if (SettingFrames[var3345aj][SelectedFrame].SlideUpDown == 0)
      {
        if (UserSettings[var3345aj].OffsetEnable == false) 
        {
          if (WorkSpaceButtons[6].Selected == false) 
          {
            RadialOpen=true;
            image(RadialMenu, LEDIcon[i].xpos-50, LEDIcon[i].ypos-50);
          }
        }
        else DisplayHelp(18);
        LEDFillColor(i);
        SelectedLEDico=i;   
        SelectedLED = temp; 
        
      }
      else DisplayHelp(17);
      return; 
    }
  }
  if ( mouseX >= (centX - 25) && mouseX <= (centX+25) && mouseY >= (centY - 25) && mouseY <= (centY+25))
  {
    if (SettingFrames[var3345aj][SelectedFrame].SlideUpDown == 0)
    {
      
      
      AllTheSameFlag=true;
      image(RadialMenuLrg, centX-100, centY-100);
      RadialOpen=true;
    }
    else DisplayHelp(17);
  }
  for (int i=0;i != AddFrameButtons.length;i++)
  { 
    
    if (AddFrameButtons[i].over() && (i < UserSettings[var3345aj].FrameLength))
    { 
      if (UserSettings[var3345aj].OffsetEnable==false)
      {      
        
        AddFrameButtons[SelectedFrame].Selected=false;
        AddFrameButtons[i].Selected=true;
        AddFrameButtons[i].display();  
        AddFrameButtons[SelectedFrame].display();    
        SelectedFrame=i;     
        SettInfoButtons[var3345aj][2].Selected=false;
        SettInfoButtons[var3345aj][3].Selected=false;   
        if (SettingFrames[var3345aj][SelectedFrame].SlideUpDown == 1) 
        {
          SettInfoButtons[var3345aj][2].Selected=true;
          
        }        
        else if (SettingFrames[var3345aj][SelectedFrame].SlideUpDown == 2)
        {
          SettInfoButtons[var3345aj][3].Selected=true;      
          
        }  
        else if (UserSettings[var3345aj].FadeFlash==true) 
        {
          SettInfoButtons[var3345aj][1].Selected=true;
        }
        else 
        {        
          SettInfoButtons[var3345aj][0].Selected=true;
        }
        if (SlideFrameSliders[var3345aj].Value < 0)
        {
          SlideFrameSliders[var3345aj].Value = SlideFrameSliders[var3345aj].Value * -1;
          
        }
      }
      else DisplayHelp(13);
    }
  }
  for (int i=0;i != WorkSpaceButtons.length;i++)
  { 
    
    if (WorkSpaceButtons[i].over())
    {
      
      WorkSpaceButtons[i].display();        
      WorkSpaceButtons[i].Selected =! WorkSpaceButtons[i].Selected;
      switch(i)
      {
      case 0:
        if (UserSettings[var3345aj].OffsetEnable  == true) break; 
        UserSettings[var3345aj].FrameLength=1;
        break;
      case 1:
        if (UserSettings[var3345aj].OffsetEnable  == true) break; 
        TotalFrames=0;  
        for (int q=0; q != UserSettings.length;q++) TotalFrames = TotalFrames + UserSettings[q].FrameLength;    
        if (UserSettings[var3345aj].FrameLength != 120 && TotalFrames != DeviceMaxFrames) UserSettings[var3345aj].FrameLength++;
        else DisplayHelp(14);
        break;
      case 2:
        if (UserSettings[var3345aj].OffsetEnable  == true) break; 
        if (UserSettings[var3345aj].FrameLength != 1) UserSettings[var3345aj].FrameLength--; 
        TotalFrames=0;
        for (int q=0; q != UserSettings.length;q++) TotalFrames = TotalFrames + UserSettings[q].FrameLength;           
        break;
      case 3:
        DisplayHelp(16);
        
		OffsetMaxFrames[var3345aj] = UserSettings[var3345aj].FrameLength; 
        OffsetSelectedFrame = 0; 
        ColorSlider[0].Value = (int)red(var993za[var3345aj][OffsetSelectedFrame]);
        ColorSlider[1].Value = (int)green(var993za[var3345aj][OffsetSelectedFrame]);
        ColorSlider[2].Value = (int)blue(var993za[var3345aj][OffsetSelectedFrame]);     
        DisplayOffsetMenu();
        var37ad3=3;
        break;          
      case 4: 
        if (UserSettings[var3345aj].OffsetEnable  == false) DisplayHelp(15);
        UserSettings[var3345aj].OffsetEnable = false;
        WorkSpaceButtons[4].Selected=false;  
        break;
      case 5: 
        IgnoreRelease=true;
        DisplayHelp(36);
        break;   
      case 6: 
        
        IgnoreRelease=true;       
        DisplayHelp(35);            
        break;    
      case 7: 
        
        EditPaintValue =!  EditPaintValue; 
        DisplayHelp(34);   
        break;   
      case 8: 
        for (int q=0; q != LEDChanTotal;q++)
        {
          CopyStorage[q] = GreyScaleStorage[var3345aj][SelectedFrame][q];
        }
        break;
      case 9: 
        for (int q=0; q != LEDChanTotal;q++)
        {
          GreyScaleStorage[var3345aj][SelectedFrame][q] = CopyStorage[q];
        }      
        break;
      }
      GUIMenus[var37ad3].display(); 
    }  
  }
}
public void GUIPressConfigMenu() 
{  
  
  for (int i=0;i != ConfigFuncButtons.length;i++)
  {
    if (ConfigFuncButtons[i].over())
    {
      switch(i)
      {
      case 0:
        
        DisplayHelp(25);
        ConfigShape=1;
        LEDShapeBuild();
        GUIMenus[var37ad3].display();  
        break;
      case 1:
        
        DisplayHelp(25); 
        ConfigShape=2;
        LEDShapeBuild();   
        GUIMenus[var37ad3].display(); 
        break;
      case 2:
        
        DisplayHelp(25);
        ConfigShape=4;
        LEDShapeBuild();    
        GUIMenus[var37ad3].display(); 
        break;
      case 3:
        
        DisplayHelp(25);
        ConfigShape=5;
        LEDShapeBuild();    
        GUIMenus[var37ad3].display();
        break;
      case 4:
        DisplayHelp(40);
        FileBrowserAction = 1;
        selectInput("Select a file to Load:", "fileSelected");
        break;
      case 5:
        
        ConfigFuncButtons[5].Selected =! ConfigFuncButtons[5].Selected;
        break;
      case 6:
        if (ConfigFuncButtons[5].Selected == true)
        {
          
          StartDotCorrectionUpload();
        }
        break;
      } 
    }
  }
  if (ConfigButtons[49].over())
  {
    
    HoldColorPick=51;
    ColorPickerOpen=true;
    image(ColorPicker, 300, 520);
    return;
  }
  for (int i=0;i != DotCorrection.length;i++)
    if (DotCorrection[i].over())
    {
      SliderSet=7;
      SelectedSlider=i;
      DotCorrection[i].Dragging=true;
      GlobalDragging=true;
    }
  if (ConfigSliders[0].over())
  {
    SelectedSlider=0;
    SliderSet=4;
    GlobalDragging=true;
  }
  if (ConfigSliders[1].over())
  {
    SelectedSlider=1;
    SliderSet=4;
    GlobalDragging=true;
  }
  if (ColorPickerOpen==true)
  {
    int myColor=get(mouseX, mouseY);
    float myRed = myColor >> 16 & 0xFF; 
    float myGreen = myColor >> 8 & 0xFF;
    float myBlue = myColor & 0xFF;
    if (HoldColorPick==51)for (int i=0;i != LEDChanTotal;i++) ConfigButtons[i].ColBG=color(myRed, myGreen, myBlue);
    else  ConfigButtons[HoldColorPick].ColBG=color(myRed, myGreen, myBlue);
    
    ColorPickerOpen=false;
    LEDShapeBuild();
    GUIMenus[var37ad3].display();
  }
}
public void setGradient(int x, int y, float w, float h, int c1, int c2 ) {
  noFill();
    for (int i = x; i <= x+w; i++) {
      float inter = map(i, x, x+w, 0, 1);
      int c = lerpColor(c1, c2, inter);
      stroke(c);
      line(i, y, i, y+h);
    }
  
}
class LEDgraphic
{
  int ChanID;
  int xpos; 
  int ypos ; 
  int bSize;
  int cColor;
  LEDgraphic(int iChanID, int ixpos, int iypos, int ibSize, int icColor)
  {
    ChanID=iChanID; 
    xpos = ixpos;
    ypos = iypos;  
    bSize = ibSize;
    cColor = icColor;
  }
  public void display()
  {   
    float myRed = cColor >> 16 & 0xFF; 
    float myGreen = cColor >> 8 & 0xFF;
    float myBlue = cColor & 0xFF;  
  myRed =  GreyScaleStorage[var3345aj][SelectedFrame][(ChanID*3)];
  myGreen =  GreyScaleStorage[var3345aj][SelectedFrame][(ChanID*3)+1];
  myBlue =  GreyScaleStorage[var3345aj][SelectedFrame][(ChanID*3)+2]; 
    strokeWeight(1); 
    stroke((255 - myRed), (255 - myGreen), (255 - myBlue));
     
     
     if((myRed < 170 && myRed > 80) || (myGreen < 170 && myGreen > 80) || (myBlue < 170 && myBlue > 80))
    {
       stroke(255);
    }  
    fill(color(myRed, myGreen, myBlue));
    ellipse(xpos, ypos, bSize, bSize); 
    fill((255 - myRed), (255 - myGreen), (255 - myBlue));
     if((myRed < 170 && myRed > 80) || (myGreen < 170 && myGreen > 80) || (myBlue < 170 && myBlue > 80))
    {
       fill(255);
    }  
    textSize((bSize/1.75f));
    textAlign(CENTER, CENTER); 
    text((ChanID+1), xpos,ypos-(bSize/10));
    textAlign(LEFT, BASELINE);
    noStroke();
  }
  public boolean over() 
  { 
    if ( mouseX >= (xpos - (bSize/2)) && mouseX <= xpos+(bSize/2)&& mouseY >= (ypos - (bSize/2)) && mouseY <= ypos+(bSize/2)) 
    {      
      return true;
    } 
    else {
      return false;
    }
  }
}
class PatternFrames
{
  int SlideValue;
  int SlideUpDown; 
  
  PatternFrames(int iSlideValue, int iSlideUpDown)
  {
   SlideValue=iSlideValue; 
   SlideUpDown=iSlideUpDown;  
  }
}
class UserSettingsObj
{
  int Speed;
  int FrameLength;
  int SettingMapStart; 
  boolean OffsetEnable;
  boolean FadeFlash; 
  int MapStart;
  int ForwardReverse; 
  UserSettingsObj(int iSpeed, int iFrameLength, int iSettingMapStart, boolean iOffsetEnable, boolean iFadeFlash, int iMapStart,int iForwardReverse)
  {
    Speed = iSpeed;
    FrameLength = iFrameLength;
    SettingMapStart = iSettingMapStart;
    OffsetEnable = iOffsetEnable;
    FadeFlash=iFadeFlash;
    MapStart = iMapStart;
    ForwardReverse = iForwardReverse;
  }
}
class GUIMenu
{
  String Label;
  int xpos; 
  int ypos ; 
  int bWidth;
  int bHeight;
  int MenuID;
  boolean Opened;
  GUIMenu(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, int iMenuID, boolean iOpened)
  {
    Label = iLabel; 
    xpos = ixpos;
    ypos = iypos;  
    bWidth = ibWidth;
    bHeight = ibHeight;
    MenuID = iMenuID;    
    Opened = iOpened;
  }
  public void display()
  {
    
    switch(MenuID)
    {
    case 0: 
      noStroke();
      fill(SketchBGColor); 
      rect(130, 100, 740, 620);
      DisplaySettingInfo();
  
      image(SideGradient, 140, 150);
      fill(255);
      ellipse(centX, centY, 50, 50);
      fill(0);
      textSize(10);
      text("All The \n Same", centX-16, centY-2);
      FrameButtonsDisplay();  
      for (int i=0;i != (ConfigSliders[0].Value); i++) LEDIcon[i].display();
      
  if(SettingFrames[var3345aj][SelectedFrame].SlideUpDown != 0)
  {
   
   noStroke();
    fill(SketchBGColor, 128);  
    rect(240, 125, 530, 430);
    fill(255, 0 ,0);
    textSize(18);
    text("Frame set as Slide\nValues Not Editable",700,125);
    
  }
    
      if(WorkSpaceButtons[7].Selected)
      {
        stroke(255,0,0);
        strokeWeight(4);
        rect(165, 405, 30, 30);  
      }
      stroke(0,0,0);   
      strokeWeight(1);
      
      fill(PaintValue);
      rect(165, 405, 30, 30);
  
   
      noStroke(); 
      break;
    case 1:
      DisplayConfigMenu();
      break;        
    case 2:  
      DisplaySettingInfo();
      break;
    case 3: 
      DisplayOffsetMenu();
      break;  
    case 4:  
      DisplaySaveLoadMenu();
      break;        
    case 5:  
      DisplayLiveModeMenu();
      break; 
    case 6:
      DisplayLinkerMenu();
      break;   
    case 7: 
      DisplayMultiMenu();
      break;
     case 8: 
      DisplayControlMenu();
      break;     
    }
  }
  public void Toggle()
  {
    
    if (Opened == true) 
    {
      GUIMenus[var37ad3].Opened=false;
      var37ad3 = 0;
      Opened = false; 
      return;
    }
    else 
    {
      GUIMenus[var37ad3].Opened=false;
      Opened =! Opened;
      var37ad3 = MenuID;
    }
  }
  public boolean over() 
  { 
    if ( mouseX >= xpos && mouseX <= xpos+bWidth && mouseY >= ypos && mouseY <= ypos+bHeight) 
    {      
      return true;
    } 
    else {
      return false;
    }
  }
}
class Button
{
  String Label;
  int xpos; 
  int ypos ; 
  int bWidth;
  int bHeight;
  int ColBG;
  int ColHL;
  boolean Toggle;
  boolean Selected;
  Button(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, int iColBG, int iColHL, boolean iToggle, boolean iSelected)
  {
    Label = iLabel; 
    xpos = ixpos;
    ypos = iypos;  
    bWidth = ibWidth;
    bHeight = ibHeight;
    ColBG = iColBG;
    ColHL = iColHL;
    Toggle = iToggle;
    Selected = iSelected;
  }
  public void display()
  {
    strokeWeight(1);
    stroke(0); 
    if (Selected==true)
    {
      fill(ColHL); 
      rect(xpos, ypos, bWidth, bHeight, (bHeight/4));
    }
    else       
    {
      fill(ColBG);
      rect(xpos, ypos, bWidth, bHeight,  (bHeight/4));
    }
    
    fill(255); 
    textSize((bHeight/1.75f));
    text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/2), bWidth, bHeight);
    noStroke();
    if (Toggle==false) Selected = false;
  }
  public boolean over() 
  { 
    if ( mouseX >= xpos && mouseX <= xpos+bWidth && mouseY >= ypos && mouseY <= ypos+bHeight) 
    {      
      return true;
    } 
    else {
      return false;
    }
  }
} 
class SideBar
{
  String Label;
  int xpos; 
  int ypos ; 
  int bWidth;
  int bHeight;
  boolean Toggle;
  boolean Selected;
  int Type;
  SideBar(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, boolean iToggle, boolean iSelected, int iType)
  {
    Label = iLabel; 
    xpos = ixpos;
    ypos = iypos;  
    bWidth = ibWidth;
    bHeight = ibHeight;
    Toggle = iToggle;
    Selected = iSelected;
    Type = iType;
  }
  public void display()
  {
    
    
    if (Selected==true)
    {
      switch(Type)
      {
      case 0:
        blend(Loverlay, 0, 0, 120, 50, xpos, ypos, 120, 50, LIGHTEST);     
        break;
      case 1:  
        blend(Roverlay, 0, 0, 139, 38, xpos+1, ypos+1, 139, 38, LIGHTEST);
        break;
      case 2:
        blend(SaveLoadOverlay, 0, 0, 152, 52, xpos+1, ypos+1, 152, 52, LIGHTEST);
        break;  
      case 3:
        blend(PresetOverlay, 0, 0, 102, 32, xpos+1, ypos+1, 102, 32, LIGHTEST);
        break; 
      case 4:
        blend(LiveModeOverlay, 0, 0, 125, 25, xpos+1, ypos, 125, 25, LIGHTEST);
        break;
      }
    }
    noStroke();
    if (Toggle==false) Selected = false;
  }
  public boolean over() 
  { 
    if ( mouseX >= xpos && mouseX <= xpos+bWidth && mouseY >= ypos && mouseY <= ypos+bHeight) 
    {      
      return true;
    } 
    else {
      return false;
    }
  }
} 
class VertSliderBar
{
  int xpos; 
  int ypos ; 
  int Slwidth; 
  int Slheight; 
  int Value; 
  int Minimum; 
  int Maximum;
  int BgColor;
  int SlColor;
  int SelColor; 
  int StrokeColor;
  boolean CircleHandle;  
  boolean Dragging;
  
  boolean over = false;
  
  float temp1=Slwidth;
  float temp2=Maximum;
  float temp3=Value;
  float temp4=Minimum;
  float MathVar=0;
  VertSliderBar(int ixp, int iyp, int iw, int ih, int iValue, int iMin, int iMax, int iBgColor, int iSlColor, int iSelColor, int iStrokeColor, boolean iCircleHandle, boolean iDragging) 
  {   
    xpos = ixp;
    ypos = iyp;  
    Slwidth = iw;
    Slheight = ih;
    Value=iValue;
    Maximum=iMax;
    Minimum=iMin;
    BgColor=iBgColor;
    SlColor=iSlColor;
    SelColor=iSelColor;
    StrokeColor=iStrokeColor;
    CircleHandle=iCircleHandle;     
    Dragging=iDragging;
  }
  public void move () 
  {
    
    temp1 = Slheight;   
    temp3 = Value;
    temp4 = Minimum;
    MathVar = (((mouseY-ypos) / temp1)-1) *-1; 
    
    MathVar = Maximum - (MathVar*(Maximum-Minimum));   
    if (MathVar > Maximum) { 
      MathVar=Maximum;
    }
    if (MathVar < Minimum) { 
      MathVar=Minimum;
    }  
    Value=PApplet.parseInt(MathVar); 
  }
  public void display() 
  {
    stroke(StrokeColor);
    strokeWeight(1);
    
    fill(BgColor); 
    rect(xpos, ypos, Slwidth, Slheight);   
    temp1 = Slheight - Slwidth;
    temp2= Maximum;  
    temp3= Value;    
    temp4 = Minimum;
    float MathVar;
    MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + Slwidth/2;
    
    fill(color(SelColor)); 
    rect(xpos, ypos, Slwidth, MathVar);
    fill(SlColor); 
    ellipse(xpos+(Slwidth/2), ypos+MathVar, Slwidth, Slwidth); 
  }
  public boolean over() 
  { 
    if ( mouseX >= xpos && mouseX <= xpos+Slwidth && mouseY >= ypos && mouseY <= ypos+Slheight) 
    {      
      Dragging=true;
      over = true;
      return true;
    } 
    else {
      over = false;
      return false;
    }
  }
}
class SliderBar
{
  int xpos; 
  int ypos ; 
  int Slwidth; 
  int Slheight; 
  int Value; 
  int Minimum; 
  int Maximum;
  int BgColor;
  int SlColor;
  int SelColor; 
  int StrokeColor;
  boolean CircleHandle;  
  boolean Dragging;
  
  boolean over = false;
  
  float temp1=Slwidth;
  float temp2=Maximum;
  float temp3=Value;
  float temp4=Minimum;
  float MathVar=0;
  SliderBar(int ixp, int iyp, int iw, int ih, int iValue, int iMin, int iMax, int iBgColor, int iSlColor, int iSelColor, int iStrokeColor, boolean iCircleHandle, boolean iDragging) 
  {   
    xpos = ixp;
    ypos = iyp;  
    Slwidth = iw;
    Slheight = ih;
    Value=iValue;
    Maximum=iMax;
    Minimum=iMin;
    BgColor=iBgColor;
    SlColor=iSlColor;
    SelColor=iSelColor;
    StrokeColor=iStrokeColor;
    CircleHandle=iCircleHandle;     
    Dragging=iDragging;
  }
  public void move () 
  {
    
      temp1 = Slwidth;   
    temp3 = Value;
    temp4 = Minimum;
    MathVar = (((mouseX-xpos) / temp1)-1) *-1; 
    
    MathVar = Maximum - (MathVar*(Maximum-Minimum));   
    if (MathVar > Maximum) { 
      MathVar=Maximum;
    }
    if (MathVar < Minimum) { 
      MathVar=Minimum;
    }  
    Value=PApplet.parseInt(MathVar); 
  }
  public void display() 
  {
    stroke(StrokeColor);
    strokeWeight(1);
    
    fill(BgColor); 
    rect(xpos, ypos, Slwidth, Slheight);   
    if (CircleHandle==true) temp1 = Slwidth -Slheight;
    else temp1=Slwidth-(Slwidth/20);
    temp2=Maximum;  
    temp3=Value;    
    temp4 = Minimum;
    float MathVar;
    if (CircleHandle==true)
      MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + Slheight/2;
    else  
      MathVar = temp1 / (temp2 - temp4) * (temp3-temp4); 
    
    fill(color(SelColor)); 
    rect(xpos, ypos, MathVar, Slheight);
    fill(SlColor); 
    if (CircleHandle==true)   ellipse(xpos+MathVar, ypos+(Slheight/2), Slheight, Slheight); 
    else   rect((xpos+MathVar), ypos, Slwidth/20, Slheight); 
  }
  public boolean over() 
  { 
    if ( mouseX >= xpos && mouseX <= xpos+Slwidth && mouseY >= ypos && mouseY <= ypos+Slheight) 
    {      
      Dragging=true;
      over = true;
      return true;
    } 
    else {
      over = false;
      return false;
    }
  }
}
public void AlterSlide(boolean sDirection)
{
  
   SlideFrameSliders[var3345aj].Value=1;  
   if(sDirection == true)
   {
   if(SettingFrames[var3345aj][SelectedFrame].SlideUpDown == 0)
   SettingFrames[var3345aj][SelectedFrame].SlideUpDown = 1;
   else 
   SettingFrames[var3345aj][SelectedFrame].SlideUpDown = 0;
   }
   else
   {
   if(SettingFrames[var3345aj][SelectedFrame].SlideUpDown == 0)   
   SettingFrames[var3345aj][SelectedFrame].SlideUpDown = 2;
   else
   SettingFrames[var3345aj][SelectedFrame].SlideUpDown = 0;   
   }         
}
public void serialEvent(Serial myPort)
{
  
  
  
  inByte2=inByte1;
  inByte1=inByte;
  inByte = myPort.read();
  
  
  MiliSec=millis();
  
  CharCounter=0;
  if (inByte=='N' && RequestSent==true) 
  {
    
    myPort.write('G');
    ConfirmedFlag=true;
    return;
  }
  else if (inByte=='n' && ConfirmedFlag==true)  
  {
        
        RequestSent=false; 
        ConfirmedFlag=false;
    
        
    
        
        myPort.write(CmdByte); 
        myPort.write(DataByte1);
        myPort.write(DataByte2);
        
        if(LiveModeSent==true)
        {    
          LiveModeSent = false;   
          LiveMode =! LiveMode;
        }
       else if(DotCorrectionRequestSent == true)
      {
        delay(100);
       DotCorrectionRequestSent = false;
        UploadingFlag=true;   
       SendDotCorrection();
      } 
      else if(UploadRequestSent == true)
      {
        delay(500);
        UploadRequestSent=false;
        
        UploadingFlag=true;
        SendFrameData();
      } 
      else if(SettingsRequestSent == true)
      {
        delay(10);
        SettingsRequestSent=false;
        UploadingFlag=true;
         
        if(FirmwareV > 99) 
        {
        SettingsRequestSent=false;
        UploadingFlag=false;
        DisplayHelp(11); 
        return;
        }
        
        if(HardwareID==208)
        {
          if(FirmwareV == 2)  Send8Chan();
          else 
          {
          DisplayHelp(31);
          return;
          }
        }
        else
        {
        SendSettings();  
        }
      } 
      else if(DemoRequestSent == true)
      {
        delay(100);
        UploadingFlag=true;
        DemoRequestSent=false;
        SendDemo();
      }   
      return;
  } 
  
  else if (ConnectionRequestSent==true)
  {
    
    
switch(ReceptionCounter) 
{
  case 0:
    HardwareID=inByte;
    break;
  case 1:
      FirmwareV=inByte;
    break;
  case 2:
        FirmwareRev=inByte; 
        
     COMButtons[0].Selected = false;
     COMButtons[0].display();       
      COMselected=true;
      DevStatus="Connected";
      DeviceConnected=true;    
      ConnectionRequestSent=false;     
     LoadHardwareConfig(); 
      DisplayHelp(19);     
    break;
}
ReceptionCounter++;
  }
  
} 
public void draw() 
{
  CharCounter++;
  
  if (GlobalDragging==true) 
  {
    
switch(SliderSet)
{
  case 0:
    if(SpeedSliders[SelectedSlider].Dragging==true) 
    { 
      
      SpeedSliders[SelectedSlider].move(); 
      SpeedSliders[SelectedSlider].display();
      DisplaySettingInfo();
    }   
    break;
  case 1:
    if (GreyValueSliders[SelectedSlider].Dragging==true) 
    { 
      
      GreyValueSliders[SelectedSlider].move(); 
      GreyValueSliders[SelectedSlider].display();
          
if(EditPaintValue == true)
{      
   switch(SettingInfoColSelect)
  {
    case 0:
    PaintValue = color(GreyValueSliders[SelectedSlider].Value, green(PaintValue), blue(PaintValue));
    break;
    case 1:
    PaintValue = color(red(PaintValue), GreyValueSliders[SelectedSlider].Value, blue(PaintValue));
    break;
    case 2:
    PaintValue = color(red(PaintValue), green(PaintValue), GreyValueSliders[SelectedSlider].Value);
    break;
  }    
}
else
{
   switch(SettingInfoColSelect)
  {
    case 0:
        GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)] = GreyValueSliders[SelectedSlider].Value;
    break;
    case 1:
      GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+1] = GreyValueSliders[SelectedSlider].Value;  
    break;
    case 2:
       GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+2] = GreyValueSliders[SelectedSlider].Value; 
    break;
  }    
}
     GUIMenus[var37ad3].display();
     DisplaySettingInfo();
    } 
    break;       
   case 2:
    if (SlideFrameSliders[SelectedSlider].Dragging==true) 
    { 
      
      SlideFrameSliders[SelectedSlider].move(); 
      SlideFrameSliders[SelectedSlider].display();
      DisplaySettingInfo();
    } 
    break;   
  case 3:
   if (ColorSlider[SelectedSlider].Dragging==true) 
    { 
      
     ColorSlider[SelectedSlider].move(); 
     ColorSlider[SelectedSlider].display();    
     DisplayOffsetMenu();
     
     var993za[var3345aj][OffsetSelectedFrame] = color(ColorSlider[0].Value,ColorSlider[1].Value,ColorSlider[2].Value);    
    }
    break;
  case 4:
    if (ConfigSliders[SelectedSlider].Dragging==true) 
    { 
      
      ConfigSliders[SelectedSlider].move(); 
      ConfigSliders[SelectedSlider].display();
      
      if (ConfigSliders[SelectedSlider].Value > ((LEDChanTotal/3) * DeviceMaxPerChan))
      {
        ConfigSliders[SelectedSlider].Value = ((LEDChanTotal/3) * DeviceMaxPerChan);
        
      }
      float SnapValue = (float)ConfigSliders[SelectedSlider].Value / (LEDChanTotal/3);
      if (SnapValue != 0) ConfigSliders[SelectedSlider].Value = round(SnapValue) * (LEDChanTotal/3);
      LEDShapeBuild();
      GUIMenus[var37ad3].display();
    }
   break;
  case 5:
    if (LiveModeSliders[SelectedSlider].Dragging==true) 
    { 
      
      LiveModeSliders[SelectedSlider].move(); 
      LiveModeSliders[SelectedSlider].display();
      SendLive(4);
      GUIMenus[var37ad3].display();
    }
   break;
  case 6:
    if (MultiSliders[SelectedSlider].Dragging==true) 
    { 
      
      MultiSliders[SelectedSlider].move(); 
      MultiSliders[SelectedSlider].display();
      GUIMenus[var37ad3].display();
    }
   break;
  case 7:
    if (DotCorrection[SelectedSlider].Dragging==true) 
    { 
      
      DotCorrection[SelectedSlider].move(); 
      DotCorrection[SelectedSlider].display();
      GUIMenus[var37ad3].display();
    }
   break;   
  case 8:
    if (ControlSlider[0].Dragging==true) 
    { 
      
      ControlSlider[0].move(); 
      ControlSlider[0].display();
      GUIMenus[var37ad3].display();
    }
     else if (ControlSlider[1].Dragging==true) 
    { 
      
      ControlSlider[1].move(); 
      ControlSlider[1].display();
      ControlSlider[0].Value =0;
      ControlSlider[0].Maximum = 65535 /   ControlSlider[1].Value;
      
      GUIMenus[var37ad3].display();
    }   
    
   break;      
}
}
  
  if(AutoConnect==true) 
  {
    
    AutoCount++;
    if (AutoCount >= 4)
    {
      try{
      myPort.stop(); 
      }
      catch(Exception e)
      {
      
      }
      COMselected=false;
      AutoCount=0;
      if (Serial.list().length > (AutoTry+1))
      {
        AutoTry++;
        
        
        COMConnect(AutoTry);  
        
        COMButtons[AutoTry+1].Selected=true;;  
        COMButtons[AutoTry+1].display();       
        COMselected=true;  
      }
      else
      {
       AutoConnect=false;
       COMButtons[AutoTry].Selected=false;  
       COMButtons[AutoTry].display();
       portName="None";
        
      COMButtons[0].display();       
      DisplayHelp(3);
      }
    } 
  } 
  
  if(LineDraggingLinker==true) 
  {
  if(var37ad3==6)GUIMenus[6].display();
  else if(var37ad3==7)GUIMenus[7].display();
  }
} 
public void SendLive(int x)
{

for(int i=0; i != LEDChanTotal;i++) 
{ 
 try{
 myPort.write(LiveModeSliders[i].Value);
 }
 catch(Exception e)
 {
   DisplayHelp(5);
   
 }
}
}
public void LoadSavePreview(String PassedLocation)
{
 
 String[] lines = loadStrings(PassedLocation); 
 int sLines=0;    
 PrevString=split(lines[sLines], '\t');
}
public void LoadUserConfigs(String PassedLocation)
{
  
  String[] lines = loadStrings(PassedLocation); 
  int sLines=0;  
  int SLChanMax=0;
  String[] WorkString= new String[300];

  WorkString = split(lines[sLines], '\t');
if(LEDChanTotal != PApplet.parseInt(WorkString[1]))
{
  DisplayHelp(33);
  return;
}
  DisplayHelp(19);
  SLChanMax = PApplet.parseInt(WorkString[1]);  
  LEDTotal = PApplet.parseInt(WorkString[2]);
  ConfigShape = PApplet.parseInt(WorkString[3]);
  
  
  
  int FramesSaved = PApplet.parseInt(WorkString[7]);
  
  sLines++;
  WorkString = split(lines[sLines], '\t');
  for (int q=0; q != 8;q++) LinkerMap[q] =  PApplet.parseInt(WorkString[q+1]);
  sLines++;
  WorkString = split(lines[sLines], '\t'); 
  for (int i=0; i != 8;i++) SpeedSliders[i].Value = PApplet.parseInt(WorkString[i+1]);
  for (int q=0; q != 8;q++) 
  {
    sLines++;
    WorkString = split(lines[sLines], '\t');       
    for (int i=0; i != LEDChanTotal;i++)  
    {
      var388sa[q][i] = PApplet.parseInt(WorkString[i+1]);
    }
  }
 
  
  for (int q=0; q != 8;q++) 
  {
  sLines++;
  WorkString = split(lines[sLines], '\t');  
    for (int i=0; i != 16;i++)  
    {
     var993za[q][i] = color(PApplet.parseInt(WorkString[(i*3)+1]),PApplet.parseInt(WorkString[(i*3)+2]),PApplet.parseInt(WorkString[(i*3)+3])); 
    }   
  }   
  
  
  for (int q=0; q != 8;q++) 
  { 
    sLines++;
    WorkString = split(lines[sLines], '\t');  
    UserSettings[q].Speed = PApplet.parseInt(WorkString[1]);
    UserSettings[q].FrameLength = PApplet.parseInt(WorkString[2]);
    UserSettings[q].ForwardReverse = PApplet.parseInt(WorkString[3]);
    UserSettings[q].OffsetEnable = PApplet.parseBoolean(WorkString[4]);
    UserSettings[q].FadeFlash = PApplet.parseBoolean(WorkString[5]);
    UserSettings[q].MapStart = PApplet.parseInt(WorkString[6]);
  }
  for (int i=0; i != 8;i++) 
  { 
    sLines++;
    WorkString = split(lines[sLines], '\t'); 
    for (int q=0; q != UserSettings[i].FrameLength;q++) 
    {      
      SettingFrames[i][q].SlideUpDown = PApplet.parseInt(WorkString[q+1]);
    }   
    sLines++;
    WorkString = split(lines[sLines], '\t');    
    for (int q=0; q != UserSettings[i].FrameLength;q++) 
    {   
      SettingFrames[i][q].SlideValue = PApplet.parseInt(WorkString[q+1]);
    }
  }
  
  for (int i=0; i != 4;i++) 
  { 
    sLines++;
    WorkString = split(lines[sLines], '\t'); 
    for (int q=0; q != 12;q++) 
    {      
    MultiLinkerMap[i][q] = PApplet.parseInt(WorkString[q+1]);
    }   
    sLines++;
    WorkString = split(lines[sLines], '\t');    
    for (int q=0; q != 12;q++) 
    {   
     MultiCounter[i][q] = PApplet.parseInt(WorkString[q+1]);
    }
  }
  for (int i=0;i != 8;i++)
  {
    for (int q=0;q != UserSettings[i].FrameLength;q++)
    {
      sLines++;
      WorkString = split(lines[sLines], '\t'); 
      for (int c=0;c != LEDChanTotal;c++)
      {  
      
        GreyScaleStorage[i][q][c] = PApplet.parseInt(WorkString[c+1]);
      }
    }
  }  
  
    for (int q=0; q != 8;q++) 
    { 
    var3345aj=q;
    FigureSettingsButtons();
    }
    var3345aj=0;
 
  TotalFrames=0; 
  for(int i=0; i != UserSettings.length;i++) TotalFrames = TotalFrames + UserSettings[i].FrameLength;
  LEDShapeBuild();
  Refresh();
}
public void SaveUserConfigs(String PassedLocation)
{
  
  ArrayList strs = new ArrayList(); 
  String TempS="";
  String TempS2=""; 
   
   PacketSize=0; 
   for(int q=0; q != 8;q++)  
   for(int i=0; i != UserSettings[q].FrameLength;i++)
   {
   PacketSize++;
   }
  strs.add("\t"+LEDChanTotal+"\t"+LEDTotal+"\t"+ConfigShape+"\t"+DeviceName+"\t"+FirmwareV+"\t"+month()+"/"+day()+"/"+year()+"\t"+PacketSize);
  TempS="";
  for (int q=0; q != 8;q++) TempS = TempS+"\t"+LinkerMap[q];
  strs.add(TempS);   
  TempS=""; 
  for (int i=0; i != 8;i++) TempS = TempS+"\t"+SpeedSliders[i].Value;
  strs.add(TempS);   
  
  for (int q=0; q != 8;q++) 
  {
    TempS=""; 
    for (int i=0; i != LEDChanTotal;i++) 
    {
       TempS =  TempS+"\t"+var388sa[q][i];
    }
    strs.add(TempS);   
  }
  for (int q=0; q != 8;q++) 
  {
    TempS = "";
    for (int i=0; i != 16;i++)  
    {
      TempS = TempS+"\t"+(int)red(var993za[q][i])+"\t"+(int)green(var993za[q][i])+"\t"+(int)blue(var993za[q][i]);
    }
    strs.add(TempS);   
  }
  for (int q=0; q != 8;q++) 
  {     
      TempS=""; 
      TempS = "\t"+SpeedSliders[q].Value+"\t"+UserSettings[q].FrameLength+"\t"+UserSettings[q].ForwardReverse+"\t"+
      UserSettings[q].OffsetEnable+"\t"+UserSettings[q].FadeFlash+"\t"+UserSettings[q].MapStart; 
      strs.add(TempS); 
  }
  for (int i=0; i != 8;i++) 
  {     
    TempS="";  
    TempS2="";  
    for (int q=0; q != UserSettings[i].FrameLength;q++) 
    {     
      TempS = TempS+"\t"+SettingFrames[i][q].SlideUpDown;
      TempS2 = TempS2+"\t"+SettingFrames[i][q].SlideValue;
    }
  strs.add(TempS); 
  strs.add(TempS2);  
  }
  for (int i=0; i != 4;i++) 
  {    
    TempS="";   
    TempS2="";  
    for (int q=0; q != 12;q++) 
    {     
      TempS = TempS+"\t"+MultiLinkerMap[i][q];
      TempS2 = TempS2+"\t"+MultiCounter[i][q];
    }
  strs.add(TempS); 
  strs.add(TempS2);  
  }
  for (int i=0;i != 8;i++) 
  {  
    for (int q=0;q != UserSettings[i].FrameLength;q++)
    {
      TempS="";  
      for (int c=0;c != LEDChanTotal;c++)
      {  
        TempS = TempS+"\t"+GreyScaleStorage[i][q][c];
      }
        strs.add(TempS);  
    }
  }
 
String[] lines = new String[strs.size()]; 
for(int q=0; q != strs.size();q++)  
{
  lines[q]=(String) strs.get(q); 
} 
String[]  WorkString = split(PassedLocation, '.'); 
saveStrings(WorkString[0]+".csmm", lines);
}
public void keyPressed() 
{
  
  
  if (key==CODED && var37ad3==0) 
  {
    switch(keyCode)
    {
    case RIGHT:
      if (SlideFrameSliders[var3345aj].Value != 127 && SettingFrames[var3345aj][SelectedFrame].SlideUpDown != 0)
      {
        
        SlideFrameSliders[var3345aj].Value++;
        SettingFrames[var3345aj][SelectedFrame].SlideValue =  SlideFrameSliders[var3345aj].Value; 
        DisplaySettingInfo();
      } 
      break;
    case LEFT:
      if (SlideFrameSliders[var3345aj].Value != 1 && SettingFrames[var3345aj][SelectedFrame].SlideUpDown != 0)
      {
        SlideFrameSliders[var3345aj].Value--;   
        
        SettingFrames[var3345aj][SelectedFrame].SlideValue = SlideFrameSliders[var3345aj].Value;
        DisplaySettingInfo();
      } 
      break;    
    case UP:
      if (UserSettings[var3345aj].OffsetEnable == false && GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+SettingInfoColSelect] != 255)
      {
        GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+SettingInfoColSelect]++;
        DisplaySettingInfo();
        GUIMenus[var37ad3].display();
      }
      break;
    case DOWN:
      if (UserSettings[var3345aj].OffsetEnable == false && GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+SettingInfoColSelect] != 0)
      {
        GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+SettingInfoColSelect]--;
        DisplaySettingInfo();
        GUIMenus[var37ad3].display();
      }
      break;
    }
  }
  if (key =='r') Refresh();
if(key == 'y')
{
 
 
 
 if(var37ad3 == 3)
 {
 ColorSlider[0].Value = round(random(255));
 ColorSlider[1].Value = round(random(255));
 ColorSlider[2].Value = round(random(255));  
 var993za[var3345aj][OffsetSelectedFrame] = color(ColorSlider[0].Value,ColorSlider[1].Value,ColorSlider[2].Value);  
GUIMenus[3].display();
 }
 else
 {
          GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)] = round(random(255));
          GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+1] = round(random(255));     
          GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+2] = round(random(255));
          Refresh();
}
} 
  if (key==3) 
  {
    
    DisplayHelp(37);  
    for (int q=0; q != LEDChanTotal;q++)
    {
      CopyStorage[q] = GreyScaleStorage[var3345aj][SelectedFrame][q];
    }
  }
  if (key==22)
  {
    
    DisplayHelp(38);
    for (int q=0; q != LEDChanTotal;q++)
    {
      GreyScaleStorage[var3345aj][SelectedFrame][q] = CopyStorage[q];
    }  
    Refresh();
  }
if(key == 'o') myPort.write(0);
if(key == 'x')
{
    SendRequest(); 
    CmdByte=3; 
    DataByte1=0;
    DataByte2=0;  
}
  if (key == 'p') 
  { 
   
    SendRequest(); 
    CmdByte=62; 
    DataByte1=0;
    DataByte2=0;  
  }
  
if(key == 'b')
{
 
    SendRequest(); 
    CmdByte=99; 
    DataByte1=0;
    DataByte2=0;  
}
if(key == 't')
{
 
    SendRequest(); 
    CmdByte=85; 
    DataByte1=0;
    DataByte2=255;    
}
if(key == 'i')
{
 
    SendRequest(); 
    CmdByte=80;
    DataByte1=0;
    DataByte2=0;    
}
if(key == 'k')
{
 
    SendRequest(); 
    CmdByte=82; 
    DataByte1=1;
    DataByte2=0;    
}
if(key == 'l')
{
 
    SendRequest(); 
    CmdByte=82; 
    DataByte1=0;
    DataByte2=0;    
}
if(key > 48 && key < 57)
{
   
    SendRequest(); 
    CmdByte=224; 
    DataByte1=key-49;
    DataByte2=0;  
}
}
public void mousePressed()
{
  if (UploadingFlag==true)
  {
    
    return;
  }
  if (mouseButton == RIGHT) 
  if (mouseButton == RIGHT) 
  if ((mouseButton == RIGHT && LineDraggingLinker == true)) 
  {
    LineDraggingLinker = false; 
    if (var37ad3==7) MultiLinkerMap[SelectedMulti][LineDragNum]=255;
    else LinkerMap[LineDragNum]=255;
  }
  
  if (WorkSpaceButtons[5].Selected == true)
  {
    
    WorkSpaceButtons[5].Selected = false;
    int myColor=get(mouseX, mouseY);
    float myRed = myColor >> 16 & 0xFF; 
    float myGreen = myColor >> 8 & 0xFF;
    float myBlue = myColor & 0xFF;  
    PaintValue = color(myRed, myGreen, myBlue);
    GUIMenus[0].display();
    return;
  }
  if (mouseY < 100)
  {
    if (COMButtons[0].over()) 
    {
      COMButtons[0].Selected = true;
      COMButtons[0].display();               
      
      AutoCount=0;
      AutoTry=0;
      
      if (COMselected==false) AutoConnect=true;
      COMConnect(AutoTry);
    }
    else
    {   
      for (int i=0; i != Serial.list().length ;i++) 
      { 
        if (COMButtons[i+1].over())
        {
          COMButtons[0].Selected = false;
          COMButtons[0].display();  
          COMButtons[i+1].Selected = true;
          COMButtons[i+1].display();
          COMConnect(i);
        }
      }
    }
    
    for (int i=0;i != Buttons.length;i++)
    { 
      if (Buttons[i].over())
      { 
        
        Buttons[i].Selected =! Buttons[i].Selected;
        Buttons[i].display();    
        switch(i)
        {
        case 0: 
         SettingsDown();     
          break; 
        case 1: 
          SettingsUp();
          break;
        }
        return; 
      }
    }
  }
  
  if (GUIMenus[2].over()) GUISettingsInfo();
  
  
  for (int i=0;i != GUIMenus.length;i++)
  {  
    if (var37ad3 == i && GUIMenus[i].over())
    {     
      
      switch(i)
      {
      case 0:
        GUIPressNoMenu(); 
        break;
      case 1:         
        GUIPressConfigMenu();
        break;        
      case 2:
        
        break; 
      case 3:
        GUIPressOffsetMenu();
        break;  
      case 4:
        GUIPressSaveLoad();
        break;        
      case 5:
        GUIPressLiveMode();
        break;  
      case 6:
        GUIPressLinker();
        break;  
      case 7:
        GUIPressMulti();
        break; 
      case 8:
        GUIPressControl();
        break;         
      default:
        
        break;
      }
      return;
    }
  }
  
  for (int i=0;i != LSideButtons.length;i++)
  { 
    
    if (LSideButtons[i].over())
    { 
      if (LSideButtons[LSideButtonsSel].Selected==true && i != LSideButtonsSel) 
      {
        
        LSideButtons[LSideButtonsSel].display();  
        DisplayHelp(21);  
        return;
      }
      LSideButtons[i].Selected=true;  
      LSideButtonsSel=i;
      LSideButtons[i].display();    
      
      switch(i)
      {
      case 0: 
        StartDemoUpload();
        LSideButtons[i].Selected=false;
        break;
      case 1:
        GUIMenus[6].Toggle();
        LSideButtons[i].Selected = GUIMenus[6].Opened;   
        DisplayHelp(27);
        break;        
      case 2:
        if (MultiSupportFlag==true)
        {
          GUIMenus[7].Toggle();
          LSideButtons[i].Selected = GUIMenus[7].Opened;
        }
        else 
        {
          DisplayHelp(4);
          LSideButtons[i].Selected=false;
        }
        break; 
      case 3:
        GUIMenus[4].Toggle();
        LSideButtons[i].Selected = GUIMenus[4].Opened;   
        if (GUIMenus[4].Opened) DisplayHelp(22);
        else DisplayHelp(19);
        break;  
      case 4:
        GUIMenus[5].Toggle();
        LSideButtons[i].Selected = GUIMenus[5].Opened; 
        if (GUIMenus[5].Opened) DisplayHelp(23);
        else DisplayHelp(19); 
        break;        
      case 5:
        GUIMenus[8].Toggle();
        LSideButtons[i].Selected = GUIMenus[8].Opened; 
        break; 
      case 6:
        GUIMenus[1].Toggle();
        LSideButtons[i].Selected = GUIMenus[1].Opened; 
        if (GUIMenus[1].Opened==true)
        {
          ShapeSize = 160; 
          centX=512;
          centY=460;
          LEDShapeBuild();
          DisplayHelp(20);
        }
        else {
          ShapeSize = 200; 
          centX=512;
          centY=340;
          LEDShapeBuild();
          DisplayHelp(19);
        }         
        break;   
      case 7:
        link("http://www.chromationsystems.com/colormotion.html", "_new");
        DisplayHelp(26);
        LSideButtons[i].Selected=false;
        break;
      default:
        break;
      }
      
      
      return;
    }
  }
  
  for (int i=0;i != RSideButtons.length;i++)
  { 
    
    if (RSideButtons[i].over() && var37ad3 == 0) 
    { 
      image(RButtons, 875, 109);
      RSideButtons[RSideButtonsSel].Selected=false;
      RSideButtons[i].Selected=true;
      for (int q=1;q != UserSettings[var3345aj].FrameLength;q++)  AddFrameButtons[q].Selected=false;     
      AddFrameButtons[0].Selected=true;
      
      RSideButtonsSel=i;
      SelectedFrame=0;
      
      LSideButtons[LSideButtonsSel].Selected=false;   
      var3345aj=i;
      var37ad3=0;
      Refresh();
    }
  }
}
public void mouseReleased()
{
  if (UploadingFlag==true) return;
  if ( IgnoreRelease==true)
  {
    IgnoreRelease=false;
    return;
  }
  if (var37ad3==0)
  {
    try {
      if (LEDIcon[SelectedLEDico].over()==false && RadialOpen==true) 
      {
        if (mouseX >= (centX - 25) && mouseX <= (centX+25) && mouseY >= (centY - 25) && mouseY <= (centY+25))
        {
          
            AllTheSameFlag=false;  
        }
        else
        {
          RadialOpen= false;
          int myColor=get(mouseX, mouseY);
          float myRed = myColor >> 16 & 0xFF; 
          float myGreen = myColor >> 8 & 0xFF;
          float myBlue = myColor & 0xFF;  
          if (AllTheSameFlag==true)
          {
            AllTheSameFlag=false;  
            for (int i=0; i != LEDChanTotal; i=i+3) 
            {
              GreyScaleStorage[var3345aj][SelectedFrame][i]=(int)myRed;  
              GreyScaleStorage[var3345aj][SelectedFrame][i+1] = (int)myGreen;       
              GreyScaleStorage[var3345aj][SelectedFrame][i+2] = (int)myBlue;
            }
            GUIMenus[var37ad3].display(); 
            return;
          }
          GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)] = (int)myRed;
          GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+1] = (int)myGreen;       
          GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+2] = (int)myBlue;
        }
      }
      else
      {
        if (WorkSpaceButtons[6].Selected == true && LEDIcon[SelectedLEDico].over()==true)
        {
           
          GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)]=(int)red(PaintValue);
          GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+1]=(int)green(PaintValue);          
          GreyScaleStorage[var3345aj][SelectedFrame][(SelectedLED*3)+2]=(int)blue(PaintValue);
        }
        else         
        
        RadialOpen = false;
      }
    }
    catch(Exception e)
    {
      DisplayHelp(5);
    }
    
  }
  
  if (ColorPickerOpen==false) Refresh();
  
  if (GlobalDragging==true)
  {
    switch(SliderSet)
    {
    case 0:
      SpeedSliders[var3345aj].Dragging=false;
      break;
      
    case 1:
      GreyValueSliders[var3345aj].Dragging=false;
      break;       
      
    case 2:
      SlideFrameSliders[var3345aj].Dragging=false;  
      if (SettInfoButtons[var3345aj][2].Selected==true)
        SettingFrames[var3345aj][SelectedFrame].SlideValue = SlideFrameSliders[var3345aj].Value;
      else if (SettInfoButtons[var3345aj][3].Selected==true)
        SettingFrames[var3345aj][SelectedFrame].SlideValue = SlideFrameSliders[var3345aj].Value; 
      
      break;   
      
    case 3:
      
      ColorSlider[SelectedSlider].Dragging=false;
      break;
      
    case 4:
      ConfigSliders[SelectedSlider].Dragging=false; 
      break;
      
    case 5:
      LiveModeSliders[SelectedSlider].Dragging=false;
      break;   
      
    case 6:
      MultiSliders[SelectedSlider].Dragging=false;
      break;
    case 7:
      DotCorrection[SelectedSlider].Dragging=false;
      break;     
    case 8:
      ControlSlider[SelectedSlider].Dragging=false;
      break;      
    }
    GlobalDragging=false;
  }
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "ColorMotionV2" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
